/* ================================================================================================ /
*
*	Diablo Mod: 
*	------------------
*
*	Version:	4.1
*	Bugs:		Currently none (please report)
*	Need:		This compiled and items files
*	Works with:	AMXX  Cs 1.6
*
*	Installation:
*	-------------------
*	Copy script into plugins and edit plugins.ini
*	Copy item diablo directory into addons/amxmodx
*	If you amx directory is not called addons/amxmodx/.. just create a new path
*
*	Credits:
*	-----------------
*	Whomever made the deagle model i'm using
*	Spacedude
*	Some others back when amx mod started :]	
*	twistedeuphoria
*
*	diablo_xpbonus = Xp on each kill (without bonus)
*	diablo_durability = Will your item loose durability on damage? And how much each time
*	diablo_saveitems = Save items when map changes
*	diablo_spawnchance = 1/x chance to spawn powrerop on each roundstart
*
/ ================================================================================================= */

new Basepath[50] = "addons/amxmodx/diablo/"	//Path from Cstrike base directory

#include <amxmodx>
#include <engine>
#include <fakemeta> 
#include <fun>
#include <cstrike>
#include <amxmisc>

#define RESTORETIME 30.0	 //How long from server start can players still get their item trasferred (s)
#define MAX 32			 //Max number of valid player entities

/* DECLARATION OF THE GLOBAL VARIABLE ============================================================= */

new gmsgFade, gmsgDeathMsg, gmsgStatusText, gmsgBartimer,gmsgScoreInfo
new gibs, white, fire, beam, boom, line, lgt
new LastTime
new bool:freeze_ended, c4state[MAX], c4bombc[MAX][3], c4fake[33], fired[33], bool:ghost_check, ghosttime[33],ghoststate[33]

new player_xp[33] = 0		//Holds players experience
new player_lvl[33] = 1		//Holds players level
new player_point[33] = 0		//Holds players level points
new player_item_id[33] = 0	//Items id
new player_item_name[33][128]   //The items name
new player_intelligence[33]
new player_strength[33]
new player_agility[33]
new player_dextery[33]
new player_class[33]		//Players class


new player_b_vampire[33] = 0	//Vampyric damage
new player_b_damage[33] = 0	//Bonus damage
new player_b_money[33] = 0	//Money bonus
new player_b_gravity[33] = 0	//Gravity bonus : 1 = best
new player_b_inv[33] = 0		//Invisibility bonus
new player_b_grenade[33] = 0	//Grenade bonus = 1/chance to kill
new player_b_reduceH[33] = 0	//Reduces player health each round start
new player_b_theif[33] = 0	//Amount of money to steal
new player_b_respawn[33] = 0	//Chance to respawn upon death
new player_b_explode[33] = 0	//Radius to explode upon death
new player_b_heal[33] = 0	//Ammount of hp to heal each 5 second
new player_b_gamble[33] = 0	//Random skill each round : value = vararity
new player_b_blind[33] = 0	//Chance 1/Value to blind the enemy
new player_b_fireshield[33] = 0	//Protects against explode and grenade bonus 
new player_b_meekstone[33] = 0	//Ability to lay a fake c4 and detonate 
new player_b_teamheal[33] = 0	//How many hp to heal when shooting a teammate 
new player_b_redirect[33] = 0	//How much damage will the player redirect 
new player_b_fireball[33] = 0	//Ability to shot off a fireball value = radius
new player_b_ghost[33] = 0	//Ability to walk through stuff
new player_b_eye[33] = 0		//Ability to place camera
new player_b_railgun[33] = 0	//Ability to get a railgun
new player_b_windwalk[33] = 0	//Ability to windwalk away
new player_b_usingwind[33] = 0	//Is player using windwalk
new player_b_reverse[33] = 0	//Ability to reverse other players controls on hit
new player_b_froglegs[33] = 0	//Ability to hold down duck for 4 sec to frog-jump
new player_b_silent[33]	= 0	//Is player silent
new player_b_dagon[33] = 0	//Ability to nuke an opponent
new player_b_sniper[33] = 0	//Ability to kill in 1/sniper with scout
new player_b_jumpx[33] = 0	//Ability to double jump
new player_b_smokehit[33] = 0	//Ability to hit and kill with smoke :]
new player_b_extrastats[33] = 0	//Ability to gain extra stats

new player_dc_name[33][99]	//Information about last disconnected players name
new player_dc_item[33]		//Information about last disconnected players item
new player_c_name[33][50]	//Information about last map->now
new player_c_item[33]		//Information about alst map->now
new Float:player_b_oldsen[33]	//Players old sens


new bool:itemrestore = true	//Can playere restore item
new bool:updatedtable = false	//Has restore table been updated?
new bool:player_b_dagfired[33]	//Fired dagoon?
new jumps[33]			//Keeps charge with the number of jumps the user has made
new bool:dojump[33]		//Are we jumping?
new item_boosted[33]		//Has this user boosted his item?

new item_durability[33]		//Durability of hold item

new LeaderCT = -1
new LeaderT = -1

enum { SORC = 1, MONK, PALADIN, ASSASSIN, NECROMANCER, BARBARIAN }
new Race[6][16] = { "Sorcerer","Monk","Paladin","Assassin","Necrom","Barbarian" }

//Used for powerupsystem
new CTstart[3]
new Tstart[3]
new NextPowerup[3]
new bool:spawnset = false
new bool:havespawn = false




/* PLUGIN CORE REDIRECTING TO FUNCTIONS ========================================================== */

public plugin_init()
{
	register_plugin("DiabloMod","4.0","Morten") 
	register_event("CurWeapon","CurWeapon","be") 
	register_event("ResetHUD", "ResetHUD", "abe")
	register_event("DeathMsg","DeathMsg","ade") 
	register_event("Damage", "Damage", "b", "2!0")
	register_event("SendAudio","freeze_over","b","2=%!MRAD_GO","2=%!MRAD_MOVEOUT","2=%!MRAD_LETSGO","2=%!MRAD_LOCKNLOAD")
	register_event("SendAudio","freeze_begin","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw") 
	register_event("SendAudio", "award_plant", "a", "2&%!MRAD_BOMBPL")
	register_event("SendAudio", "award_defuse", "a", "2&%!MRAD_BOMBDEF")  
	register_event( "TextMsg", "award_hostageALL", "a", "2&#All_Hostages_R" ); 
	register_event("TextMsg","host_killed","b","2&#Killed_Hostage") 
	register_event("SendAudio","eventGrenade","bc","2=%!MRAD_FIREINHOLE")
	register_clcmd("say /dropitem","dropitem") 
	register_clcmd("dropitem","dropitem") 
	register_clcmd("/dropitem","dropitem") 
	register_clcmd("say /iteminfo","iteminfo")
	register_clcmd("iteminfo","iteminfo")
	register_clcmd("/iteminfo","iteminfo")
	register_clcmd("say /helpme","helpme") 
	register_clcmd("say /help","helpme") 
	register_clcmd("say /info","helpme")
	register_clcmd("say /menu","showmenu") 
	register_clcmd("menu","showmenu")
	register_clcmd("helpme","helpme") 
	register_clcmd("say /rune","buyrune") 
	register_clcmd("/rune","buyrune") 
	register_clcmd("rune","buyrune") 
	register_clcmd("usemagic","check_magic") 
	register_clcmd("ultimate","check_magic") 
	register_clcmd("giveitem","giveitem") 
	register_clcmd("/skills","showskills")
	register_clcmd("/skillsinfo","showskills")
	register_clcmd("say /skillsinfo","showskills")
	register_clcmd("say /skills","showskills")
	register_menucmd(register_menuid("Select skill"), 1023, "skill_menu")
	register_menucmd(register_menuid("Options"), 1023, "option_menu")
	register_menucmd(register_menuid("Select Class "), 1023, "select_class_menu")
	register_menucmd(register_menuid("Select Rune "), 1023, "select_rune_menu")
	gmsgDeathMsg = get_user_msgid("DeathMsg")
	gmsgStatusText = get_user_msgid("StatusText")
	gmsgFade = get_user_msgid("ScreenFade")
	gmsgBartimer = get_user_msgid("BarTime") 
	gmsgScoreInfo = get_user_msgid("ScoreInfo") 
	register_cvar("diablo_saveitems","1",0) 
	register_cvar("diablo_xpbonus","25",0) 
	register_cvar("diablo_durability","10",0) 
	register_cvar("diablo_spawnchance","2",0)
	set_msg_block ( gmsgDeathMsg, BLOCK_SET ) 
	set_task(1.0, "TimedFunctions", 0, "", 0, "b")
	set_task(0.8, "UpdateHUD",0,"",0,"b")
	set_task(RESTORETIME, "DisableItemRestore",0,"",0,"a")
	register_think("PlayerCamera","Think_PlayerCamera");
	register_think("PowerUp","Think_PowerUp")
	register_think("Creep","Think_Creep")
	register_logevent("RoundStart", 2, "0=World triggered", "1=Round_Start")
	register_clcmd("fullupdate","fullupdate")
	return PLUGIN_CONTINUE  
}

public plugin_precache()
{ 
	new v_deagle[50],p_deagle[50]
	format(v_deagle,49,"%s%s",Basepath,"v_deagle.mdl")
	format(p_deagle,49,"%s%s",Basepath,"p_deagle.mdl")
		
	white = precache_model("sprites/white.spr") 
	fire = precache_model("sprites/explode1.spr") 
	gibs = precache_model("models/hgibs.mdl")
	beam = precache_model("sprites/zbeam4.spr") 
	precache_model("models/rpgrocket.mdl")
	boom = precache_model("sprites/zerogxplode.spr") 
	line = precache_model("sprites/dot.spr")
	lgt = precache_model("sprites/lgtning.spr")
	precache_model(v_deagle)
	precache_model(p_deagle)
	precache_model("models/bag.mdl")
	precache_model("models/zombie.mdl")
}

public freeze_over()
{
	freeze_ended = true
}

public freeze_begin()
{
	freeze_ended = false
}

public RoundStart()
{
	Findleader()
	SpawnPowerup()
	Bot_Dropitem()
}

//helper
public giveitem(id)
{
	//award_item(id,49)
	return PLUGIN_HANDLED
}

/* BASIC FUNCTIONS ================================================================================ */

public CurWeapon(id)
{
	if (is_user_connected(id) == 1)
	{
		new clip, ammo
		new weapon = get_user_weapon(id,clip,ammo)
	
		if (player_item_id[id] == 17 || player_b_usingwind[id] == 1) engclient_cmd(id,"weapon_knife") 	
		if (player_b_railgun[id] > 0 && weapon == CSW_KNIFE) Setup_Railgun(id)
		if (player_dextery[id] > 0 || player_class[id] == ASSASSIN) 
		{
			if (weapon != CSW_KNIFE) 
			{
				new bonus = 0
				if (player_class[id] == ASSASSIN) bonus = 5
				set_user_maxspeed(id,250.0+player_dextery[id]*2 + bonus)
			}
			else 
				set_user_maxspeed(id,252.0+player_dextery[id]*2)
		}

		
		add_inv_bonus(id)
		write_hud(id)
	}
}


public ResetHUD(id)
{
	if (is_user_connected(id) == 1)
	{
		
		add_strength_bonus(id)
		if (c4fake[id] > 0)
		{
			remove_entity(c4fake[id])
			c4fake[id] = 0
		}

		if (fired[id] > 0) fired[id] = 0
		if (player_b_dagfired[id]) player_b_dagfired[id] = false
		if (ghoststate[id] > 0) ghoststate[id] = 0
		if (player_b_usingwind[id] > 0) 
		{
			player_b_usingwind[id] = 0
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
		}

		if (player_point[id] > 0 ) skilltree(id)
		if (player_class[id] == 0) select_class(id)

		add_bonus_gamble(id)				//MUST be first
		c4state[id] = 0
		client_cmd(id,"hud_centerid 0")  
		client_cmd(id,"setinfo ah_ 0") 
		auto_help(id)
		add_money_bonus(id)
		add_gravity_bonus(id)
		add_redhealth_bonus(id)
		SelectBotRace(id)
	}
}

public DeathMsg()
{
	new kid = read_data(1)
	new vid = read_data(2) 
	new headshot = read_data(3)
	new weaponname[20]; read_data(4,weaponname,31)
	if (is_user_connected(kid) == 1 && is_user_connected(vid) == 1 && get_user_team(kid) != get_user_team(vid))
	{
		show_deadmessage(kid,vid,headshot,weaponname)
		award_item(kid,0)
		award_xp(kid,vid)
		add_respawn_bonus(vid)
		add_bonus_explode(vid)
		add_barbarian_bonus(kid)
		register_place(kid)
	}
}

public Damage(id)
{
	if (is_user_connected(id) == 1)
	{
		new damage = read_data(2)
		new weapon
		new bodypart
		new attacker_id = get_user_attacker(id,weapon,bodypart) 
		if (is_user_connected(attacker_id) == 1 && attacker_id != id)
		{
			add_damage_bonus(id,damage,attacker_id)
			add_vampire_bonus(id,damage,attacker_id)
			add_grenade_bonus(id,attacker_id,weapon)
			add_theif_bonus(id,attacker_id)
			add_bonus_blind(id,attacker_id,weapon,damage)
			add_bonus_confuse(id,attacker_id)
			add_bonus_teamheal(id)
			add_bonus_redirect(id)
			add_bonus_necromancer(attacker_id,id)
			add_bonus_scoutdamage(attacker_id,id,weapon)		
			item_take_damage(id,damage)
		}
	}
}

public client_PreThink ( id ) 
{
	if (player_b_jumpx[id] > 0) Prethink_Doublejump(id)
	if (player_b_railgun[id] > 0) Prethink_railgun(id)	
	if (player_b_usingwind[id] == 1) Prethink_usingwind(id)
	if (player_b_oldsen[id] > 0) Prethink_confuseme(id)
	if (player_b_froglegs[id] > 0) Prethink_froglegs(id)
	if ((player_b_silent[id] > 0 || player_class[id] == ASSASSIN) && is_user_alive(id)) entity_set_int(id, EV_INT_flTimeStepSound, 999)
	
	return PLUGIN_CONTINUE	
	
}

public client_PostThink( id )
{
	if (player_b_jumpx[id] > 0) Postthink_Doubeljump(id)
}

/* FUNCTIONS ====================================================================================== */

public skilltree(id)
{
	new text[513] 
	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)


	format(text, 512, "\ySelect skill - \rPoints: %i^n^n\w1. Intelligence [%i] [More Spell Damage]^n\w2. Strength [%i] [More Hitpoints]^n\w3. Agility [%i] [Improved Magic find]^n\w4. Dextery [%i] [Improved Speed]",player_point[id],player_intelligence[id],player_strength[id],player_agility[id],player_dextery[id]) 

	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)
	show_menu(id, keys, text) 
	return PLUGIN_HANDLED  
} 


public skill_menu(id, key) 
{ 
	switch(key) 
	{ 
		case 0: 
		{	
			player_point[id]-=1
			player_intelligence[id]+=1
			
		}
		case 1: 
		{	
			player_point[id]-=1	
			player_strength[id]+=1
		}
		case 2: 
		{	
			player_point[id]-=1
			player_agility[id]+=1
		}
		case 3: 
		{	
			player_point[id]-=1
			player_dextery[id]+=1
		}
	}

	if (player_point[id] > 0) skilltree(id)
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public show_deadmessage(killer_id,victim_id,headshot,weaponname[])
{
	if (!(killer_id==victim_id && !headshot && equal(weaponname,"world")))
	{
		message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0)
		write_byte(killer_id)
		write_byte(victim_id)
		write_byte(headshot)
		write_string(weaponname)
		message_end()
	}
}

/* ==================================================================================================== */

public award_plant(id)
{
	for (new id=0; id < MAX; id++)
	{
		if (is_user_connected(id) == 1 && is_user_alive(id))
		{
			new team[32]
			get_user_team(id,team,31)
			if (!equal(team,"TERRORIST"))
				continue
			
			player_xp[id]+=get_cvar_num("diablo_xpbonus")
							
			if (player_lvl[id] == 1)
			{
				player_lvl[id]+=1
				player_point[id]+=2
				set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
				show_hudmessage(id, "You advanced to Level %i", player_lvl[id]) 
			}
			
			if (player_xp[id] > calc_xp(player_lvl[id]) && player_lvl[id] != 1)
			{
				player_lvl[id]+=1
				player_point[id]+=2
				set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
				show_hudmessage(id, "You advanced to Level %i", player_lvl[id]) 
			}
			
			write_hud(id)
		}
	}
				
}


public award_defuse()
{
	for (new id=0; id < MAX; id++)
	{
		if (is_user_connected(id) == 1 && is_user_alive(id))
		{
			new team[32]
			get_user_team(id,team,31)
			
			if (!equal(team,"CT"))
				continue 
			
			player_xp[id]+=get_cvar_num("diablo_xpbonus")
				
			if (player_lvl[id] == 1)
			{
				player_lvl[id]+=1
				player_point[id]+=2
				set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
				show_hudmessage(id, "You advanced to Level %i", player_lvl[id]) 
			}
			
			if (player_xp[id] > calc_xp(player_lvl[id]) && player_lvl[id] != 1)
			{
				player_lvl[id]+=1
				player_point[id]+=2
				set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
				show_hudmessage(id, "You advanced to Level %i", player_lvl[id]) 
			}
			
			write_hud(id)
		}
	}
}

public award_hostageALL(id)
{
	if (is_user_connected(id) == 1)
	{
		player_xp[id]+=get_cvar_num("diablo_xpbonus")
			
		if (player_lvl[id] == 1)
		{
			player_lvl[id]+=1
			player_point[id]+=2
			set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
			show_hudmessage(id, "You advanced to Level %i", player_lvl[id]) 
		}
		
		if (player_xp[id] > calc_xp(player_lvl[id]) && player_lvl[id] != 1)
		{
			player_lvl[id]+=1
			player_point[id]+=2
			set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
			show_hudmessage(id, "You advanced to Level %i", player_lvl[id]) 
		}
		
		write_hud(id)
	}
}

/* ==================================================================================================== */

public award_xp(killer_id,victim_id)
{
	player_xp[killer_id]+=get_cvar_num("diablo_xpbonus")
	
	new Team[32]
	get_user_team(killer_id,Team,31)
	
	if (LeaderCT > 0 && equal(Team,"CT") && !is_user_alive(LeaderCT))
	{
		player_xp[killer_id]-= get_cvar_num("diablo_xpbonus")/4
	}
	if (LeaderT > 0 && equal(Team,"TERRORIST") && !is_user_alive(LeaderT))
	{
		player_xp[killer_id]-= get_cvar_num("diablo_xpbonus")/4
	}
	
	if (player_class[killer_id] == MONK) player_xp[killer_id]+=get_cvar_num("diablo_xpbonus")/2
	

	if (player_xp[killer_id]*2<player_xp[victim_id]) player_xp[killer_id]+=get_cvar_num("diablo_xpbonus")/4

	if (player_lvl[killer_id] == 1)
	{
		player_lvl[killer_id]+=1
		player_point[killer_id]+=2
		set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
		show_hudmessage(killer_id, "You advanced to Level %i", player_lvl[killer_id]) 
	}
	
	if (player_xp[killer_id] > calc_xp(player_lvl[killer_id]) && player_lvl[killer_id] != 1)
	{
		player_lvl[killer_id]+=1
		player_point[killer_id]+=2
		set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
		show_hudmessage(killer_id, "You advanced to Level %i", player_lvl[killer_id]) 
	}

}

public calc_xp(lv)
{
	if (lv == 1)
	{
		return 10
	}
	else
	{
		new Float:xplimit = 308.717-337.028*lv+143.9671*(lv*lv)-16.973*(lv*lv*lv)+0.7803*(lv*lv*lv*lv)
		return floatround(xplimit)
	}
	
	return 1
}

/* ==================================================================================================== */

public client_connect(id)
{
	reset_item_skills(id)
	player_xp[id] = 0		
	player_lvl[id] = 1		
	player_point[id] = 0	
	player_item_id[id] = 0			
	player_agility[id] = 0
	player_strength[id] = 0
	player_intelligence[id] = 0
	player_dextery[id] = 0
	player_b_oldsen[id] = 0.0
	player_class[id] = 0
	
	
	//Give player item back if he had it last map
	handle_mapchange(id)
}

public client_disconnect(id)
{
	new playername[40]
	get_user_name(id,playername,39)
	player_dc_name[id] = playername
	player_dc_item[id] = player_item_id[id]
	
	if (player_b_oldsen[id] > 0.0) client_cmd(id,"sensitivity %f",player_b_oldsen[id])
}

/* ==================================================================================================== */

public write_hud(id)
{
	if (player_lvl[id] == 0)
		player_lvl[id] = 1
				
	new PlayerRace[16]
	
	if (player_class[id] <= 0)
		PlayerRace = "None"
	else
		PlayerRace = Race[player_class[id]-1]
	
	

	new tpstring[256] 
	
	if (player_item_id[id] == 0)
	{
		format(tpstring,255,"[Race: %s Xp: %i/%i Lvl: %i Item: None]", PlayerRace, player_xp[id], calc_xp(player_lvl[id]), player_lvl[id])
	}
	else
	{
		format(tpstring,255,"[Race: %s Xp: %i/%i Lvl: %i Item: %s]", PlayerRace, player_xp[id], calc_xp(player_lvl[id]), player_lvl[id],player_item_name[id])
	}
	message_begin(MSG_ONE,gmsgStatusText,{0,0,0}, id) 
	write_byte(0) 
	write_string(tpstring) 
	message_end() 
}

/* ==================================================================================================== */

public UpdateHUD()
{
		
	//Update HUD for each player
	for (new id=0; id < MAX; id++)
	{	
		//Update MANA and refresh HUD
		if (is_user_connected(id))
		{
			if (is_user_alive(id)) write_hud(id)
			else
			{
				//Show info about the player we're looking at
				new index,bodypart 
				get_user_aiming(id,index,bodypart)  
		     
				if(index >= 0 && index < MAX && is_user_connected(index) && is_user_alive(index)) 
				{
					new pname[32]
					get_user_name(index,pname,31)
					
					new PlayerRace[16]
					if (player_class[index] <= 0) PlayerRace = "None"
					else PlayerRace = Race[player_class[index]-1]
					
					new Itemname[128]
					if (player_item_id[index] == 0) Itemname = "None"
					else Itemname = player_item_name[index]
						
					new Msg[512]
					set_hudmessage(255, 255, 255, 0.02, 0.73, 0, 6.0, 3.0)
					format(Msg,511,"Name: %s^nLevel: %i^nRace: %s^nItem: %s",pname,player_lvl[index],PlayerRace,Itemname)		
					show_hudmessage(id, Msg)
					
				}
			}
		}
	}
}

/* ==================================================================================================== */

public check_magic(id)					//Redirect and check which items will be triggered
{
	if (player_b_meekstone[id] > 0) item_c4fake(id)
	if (player_b_fireball[id] > 0) item_fireball(id)
	if (player_b_ghost[id] > 0) item_ghost(id)
	if (player_b_eye[id] != 0) item_eye(id)
	if (player_b_windwalk[id] > 0) item_windwalk(id)
	if (player_b_dagon[id] > 0) item_dagon(id)
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public dropitem(id)
{
	if (player_item_id[id] == 0)
	{
		set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "You have no item to drop!") 
	} 
	else 
	{
		
		if (item_durability[id] <= 0) 
		{
			set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
			show_hudmessage(id, "Item lost due to durability!")
		}
		else 
		{
			set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
			show_hudmessage(id, "Item dropped")
		}
			
		set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,16)  
		player_item_id[id] = 0
		player_item_name[id] = ""
		player_b_gamble[id] = 0					//Because gamble uses reset skills
		if (player_b_extrastats[id] > 0)
		{
			SubtractStats(id,player_b_extrastats[id])
		}
		reset_item_skills(id)
		write_hud(id)
		Reset_Railgun(id)
		if (player_b_oldsen[id] > 0.0) 
		{
			client_cmd(id,"sensitivity %f",player_b_oldsen[id])
			player_b_oldsen[id] = 0.0
		}
		set_user_gravity(id,1.0)
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public pfn_touch ( ptr, ptd )
{	
	if (ptd == 0)
		return PLUGIN_CONTINUE
	
	new szClassName[32]
	entity_get_string(ptd, EV_SZ_classname, szClassName, 31)
	
	if (ptr != 0)
	{
		new szClassNameOther[32]
		entity_get_string(ptr, EV_SZ_classname, szClassNameOther, 31)
		
		
		if(equal(szClassName, "PowerUp") && equal(szClassNameOther, "player"))
		{
			entity_set_int(ptd,EV_INT_iuser2,1)
			award_powerup(ptr)
		}
		
		if(equal(szClassName, "grenade") && equal(szClassNameOther, "player"))
		{
			new greModel[64]
			entity_get_string(ptd, EV_SZ_model, greModel, 63)
				
			if(equali(greModel, "models/w_smokegrenade.mdl" ))	
			{
				new id = entity_get_edict(ptd,EV_ENT_owner)
				
				if (is_user_connected(id) 
				&& is_user_alive(id) 
				&& is_user_connected(ptr) 
				&& is_user_alive(ptr) 
				&& player_b_smokehit[id] > 0)
				UTIL_Kill(id,ptr,"grenade")
			}
			
			
		}
		
	}
	
	
	if(equal(szClassName, "fireball"))
	{
		new Float:vExplodeAt[3]
		entity_get_vector(ptd,EV_VEC_origin,vExplodeAt)
		new origin[3]
		origin[0] = floatround(vExplodeAt[0])
		origin[1] = floatround(vExplodeAt[1])
		origin[2] = floatround(vExplodeAt[2])
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(3)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2])
		write_short(boom)
		write_byte(50)
		write_byte(15)
		write_byte(0)
		message_end()
		new id =  entity_get_edict(ptd,EV_ENT_owner)
		remove_entity(ptd)

		for(new a = 0; a < MAX; a++)
		{ 	
			if (is_user_connected(a))
			{
				new aOrigin[3]
				get_user_origin(a,aOrigin)

				if (get_user_team(id) != get_user_team(a) && get_distance(aOrigin,origin) < player_b_fireball[id] + player_intelligence[id] && is_user_alive(a))
				{
					UTIL_Kill(id,a,"grenade")
				}
			}
		}
	}

	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public TimedFunctions()
{
	new Globaltime = floatround(Float:halflife_time())
	
	if (Globaltime - 5 > LastTime)
	{
		LastTime = Globaltime
		for(new a = 0; a < 33; a++)
		{ 
			if (is_user_connected(a))
			{		
				if (player_b_heal[a] > 0)
				{
					if (get_user_health(a)+player_b_heal[a] <= 100+player_strength[a])
					{
						set_user_health(a,get_user_health(a) + player_b_heal[a])
					} 
					else 
					{
						set_user_health(a,100+player_strength[a])
					}
				}
			}
		}
	}

	if (ghost_check == true)
	{	
		for(new a = 0; a < 33; a++)
		{ 
			if (is_user_connected(a) == 1)
			{
				if (ghoststate[a] == 1)				//Just set the state ie. he starts ghost mode
				{
						ghoststate[a] = 2
						ghosttime[a] = Globaltime
				}
				if (ghoststate[a] == 2 && Globaltime - player_b_ghost[a] > ghosttime[a])	//Ghosttime ended
				{
						ghoststate[a] = 3
						ghosttime[a] = 0
						set_user_noclip(a,0)
						ghost_check = false
						new Float:aOrigin[3]
						entity_get_vector(a,EV_VEC_origin,aOrigin)	
						
						if (PointContents (aOrigin) != -1)				//User is stuck
						{
							user_kill(a,1)	
						}
						else
						{
							aOrigin[2]+=10
							entity_set_vector(a,EV_VEC_origin,aOrigin)
						}

						
					
				}
			}
		}
	}


}


/* ==================================================================================================== */

public reset_item_skills(id)
{
	player_b_vampire[id] = 0	//Vampyric damage
	player_b_damage[id] = 0		//Bonus damage
	player_b_money[id] = 0		//Money bonus
	player_b_gravity[id] = 0	//Gravity bonus : 1 = best
	player_b_inv[id] = 0		//Invisibility bonus
	player_b_grenade[id] = 0	//Grenade bonus = 1/chance to kill
	player_b_reduceH[id] = 0	//Reduces player health each round start
	player_b_theif[id] = 0		//Amount of money to steal
	player_b_respawn[id] = 0	//Chance to respawn upon death
	player_b_explode[id] = 0	//Radius to explode upon death
	player_b_heal[id] = 0		//Ammount of hp to heal each 5 second
	player_b_blind[id] = 0		//Chance 1/Value to blind the enemy
	player_b_fireshield[id] = 0	//Protects against explode and grenade bonus 
	player_b_meekstone[id] = 0	//Ability to lay a fake c4 and detonate 
	player_b_teamheal[id] = 0	//How many hp to heal when shooting a teammate 
	player_b_redirect[id] = 0	//How much damage will the player redirect 
	player_b_fireball[id] = 0	//Ability to shot off a fireball value = radius *
	player_b_ghost[id] = 0		//Ability to walk through walls
	player_b_eye[id] = 0	         //Ability to snarkattack
	player_b_railgun[id] = 0	//Abiliy to use railgun
	player_b_windwalk[id] = 0	//Ability to windwalk
	player_b_usingwind[id] = 0	//Is player using windwalk
	player_b_reverse[id] = 0
	player_b_froglegs[id] = 0
	player_b_silent[id] = 0
	player_b_dagon[id] = 0		//Abliity to nuke opponents
	player_b_sniper[id] = 0		//Ability to kill faster with scout
	player_b_jumpx[id] = 0
	player_b_smokehit[id] = 0
	player_b_extrastats[id] = 0
	
	item_boosted[id] = 0
	item_durability[id] = 0		//Not holding an item
	jumps[id] = 0
}

/* ==================================================================================================== */

public auto_help(id)
{
	new rnd = random_num(1,6+player_lvl[id])
	if (rnd <= 6)
		set_hudmessage(0, 180, 0, -1.0, 0.70, 0, 10.0, 5.0, 0.1, 0.5, 11) 	
	if (rnd == 1)
		show_hudmessage(id, "You can drop an item by saying /dropitem and view info by saying /iteminfo")
	if (rnd == 2)
		show_hudmessage(id, "You can use specific items by typing usemagic or binding a key in the console")
	if (rnd == 3)
		show_hudmessage(id, "You can get more help by saying /helpme")
	if (rnd == 4)
		show_hudmessage(id, "Bind a key to MENU for a usefull diablo menu - this is most recommanded!")
	if (rnd == 5)
		show_hudmessage(id, "Got a great idea for an item? Send a mail to mortengryning@gmail.com")
	if (rnd == 6)
		show_hudmessage(id, "Some items can be upgraded with Runes. Type /rune for a shoplist")
}

/* ==================================================================================================== */

public helpme(id)
{	 
	showitem(id,"Helpmenu","Common","None","You gain items and xp by killing enemies, you can only gain an item if you're item slot is free<br><br>See what the item does by saying /iteminfo or drop it by saying /dropitem<br><br>Some items can be triggered by typing USEMAGIC in the console<br>")
}

/* ==================================================================================================== */


/* ==================================================================================================== */

public showitem(id,itemname[],itemvalue[],itemeffect[],Durability[])
{
	new g_motdFile[64]							
	new g_ItemFile[64]
	new amxbasedir[64]
	get_basedir(amxbasedir,63)
	
	format(g_motdFile,63,"%s/diablo/placeholder.txt",amxbasedir)
	if(file_exists(g_motdFile)) 
	{ 
		format(g_ItemFile,63,"%s/diablo/item.txt",amxbasedir)
		if(file_exists(g_ItemFile))
			delete_file(g_ItemFile)
			
		new Data[768]
					
		//Header
		format(Data,767,"<html><head><title>HelpMenu</title></head>")
		write_file(g_ItemFile,Data,-1)
		
		//Background
		format(Data,767,"<body text=^"#FFFF00^" bgcolor=^"#000000^" background=^"%sdrkmotr.jpg^">",Basepath)
		write_file(g_ItemFile,Data,-1)
		
		//Table stuff
		format(Data,767,"<table border=^"0^" cellpadding=^"0^" cellspacing=^"0^" style=^"border-collapse: collapse^" width=^"100%^"><tr><td width=^"22%^">")
		write_file(g_ItemFile,Data,-1)
		
		//ss.gif image
		format(Data,767,"<p align=^"center^"><img border=^"0^" src=^"%sss.gif^"></td>",Basepath)
		write_file(g_ItemFile,Data,-1)
			
		//item name
		format(Data,767,"<td width=^"57%^"><p align=^"center^"><font face=^"Arial^"><font color=^"#FFCC00^"><b>Item: </b>%s</font><br>",itemname)
		write_file(g_ItemFile,Data,-1)
		
		//item value
		format(Data,767,"<font color=^"#FFCC00^"><b><br>Value: </b>%s</font><br>",itemvalue)
		write_file(g_ItemFile,Data,-1)
		
		//Durability
		format(Data,767,"<font color=^"#FFCC00^"><b><br>Durability: </b>%s</font><br><br>",Durability)
		write_file(g_ItemFile,Data,-1)
			
		//Effects
		format(Data,767,"<font color=^"#FFCC00^"><b>Effect:</b> %s</font></font></td>",itemeffect)
		write_file(g_ItemFile,Data,-1)
			
		//image ss
		format(Data,767,"<td width=^"130%^"><p align=^"center^"><img border=^"0^" src=^"%sgf.gif^"></td>", Basepath)
		write_file(g_ItemFile,Data,-1)
	
		//end
		format(Data,767,"</tr></table></body></html>")
		write_file(g_ItemFile,Data,-1)
		
		//show window with message
		show_motd(id, g_ItemFile, "Item Information")
		
	}
	else 
	{
		show_motd(id, "ERROR: Server Admin please check if the folder ^"items^" is in the amx base directory and Ipatch is correctly defined", "ERROR")	
	}
}


/* ==================================================================================================== */

public iteminfo(id)
{
	new itemvalue[100]

	if (player_item_id[id] <= 10) itemvalue = "Common"
	if (player_item_id[id] <= 30) 
		itemvalue = "Uncommon"
	else 
		itemvalue = "Rare"
		
	if (player_item_id[id] > 42) itemvalue = "Unique"

	new itemEffect[200]

	new TempSkill[11]					//There must be a smarter way

	if (player_b_vampire[id] > 0) 
	{
		num_to_str(player_b_vampire[id],TempSkill,10)
		add(itemEffect,199,"Steals ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," hit points when you hit an enemy<br>")
	}
	if (player_b_damage[id] > 0) 
	{
		num_to_str(player_b_damage[id],TempSkill,10)
		add(itemEffect,199,"Does ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," Extra damage each time you damage an enemy<br>")
	}
	if (player_b_money[id] > 0) 
	{
		num_to_str(player_b_money[id],TempSkill,10)
		add(itemEffect,199,"Gives a $")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," money bonus each round start<br>")
	}
	if (player_b_gravity[id] > 0) 
	{
		num_to_str(player_b_gravity[id],TempSkill,10)
		add(itemEffect,199,"Reduces gravity with ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_inv[id] > 0) 
	{
		num_to_str(player_b_inv[id],TempSkill,10)
		add(itemEffect,199,"You visibility is reduced from 255 to ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_grenade[id] > 0) 
	{
		num_to_str(player_b_grenade[id],TempSkill,10)
		add(itemEffect,199,"You have a 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," chance that your HE will kill instantly<br>")
	}
	if (player_b_reduceH[id] > 0) 
	{
		num_to_str(player_b_reduceH[id],TempSkill,10)
		add(itemEffect,199,"Your health is reduced by ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," each round start strength does not matter here<br>")
	}
	if (player_b_theif[id] > 0) 
	{
		num_to_str(player_b_theif[id],TempSkill,10)
		add(itemEffect,199,"Your have a 1/7 chance to steal $")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," each time you hit an enemy<br>")
	}
	if (player_b_respawn[id] > 0) 
	{
		num_to_str(player_b_respawn[id],TempSkill,10)
		add(itemEffect,199,"Your have a 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," chance to respawn upon death<br>")
	}
	if (player_b_explode[id] > 0) 
	{
		num_to_str(player_b_explode[id],TempSkill,10)
		add(itemEffect,199,"When you die you will explode in a radius of ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," - intelligence boost this item<br>")
	}
	if (player_b_heal[id] > 0) 
	{
		num_to_str(player_b_heal[id],TempSkill,10)
		add(itemEffect,199,"You will gain +")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," hit points every 5 seconds<br>")
	}
	if (player_b_gamble[id] > 0) 
	{
		num_to_str(player_b_gamble[id],TempSkill,10)
		add(itemEffect,199,"You will gain a random skill each round start vararity is 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_blind[id] > 0) 
	{
		num_to_str(player_b_blind[id],TempSkill,10)
		add(itemEffect,199,"You have a 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," chance to blind the enemy when you hit him<br>")
	}
	if (player_b_fireshield[id] > 0) 
	{
		num_to_str(player_b_fireshield[id],TempSkill,10)
		add(itemEffect,199,"You can not be killed by chaos orb - hell orb or firerope<br>")
	}
	if (player_b_meekstone[id] > 0) 
	{
		num_to_str(player_b_meekstone[id],TempSkill,10)
		add(itemEffect,199,"You can lay a fake c4 by using your USEMAGIC key<br>")
	}
	if (player_b_teamheal[id] > 0) 
	{
		num_to_str(player_b_teamheal[id],TempSkill,10)
		add(itemEffect,199,"You can heal teammates ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," hit points by shooting at them<br>")
	}
	if (player_b_redirect[id] > 0) 
	{
		num_to_str(player_b_redirect[id],TempSkill,10)
		add(itemEffect,199,"You gain a damage reduction of ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," hitpoints<br>")
	}
	if (player_b_fireball[id] > 0) 
	{
		num_to_str(player_b_fireball[id],TempSkill,10)
		add(itemEffect,199,"You can cast a fireball pressing USEMAGIC - Intelligence boost this item. It will kill all in a radius of ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_ghost[id] > 0) 
	{
		num_to_str(player_b_ghost[id],TempSkill,10)
		add(itemEffect,199,"Press USEMAGIC to walk through walls in a period of ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," seconds<br>")
	}
	if (player_b_eye[id] > 0) 
	{
		add(itemEffect,199,"Press USEMAGIC to place a magic eye (only one placement allowed) and USEMAGIC again to use it or stop ")

	}
	if (player_b_railgun[id] > 0) 
	{
		add(itemEffect,199,"Your knife is replaced with a railgun, note that sometimes the railgun will miss even though the shot hit")
	}

	if (player_b_windwalk[id] > 0) 
	{
		num_to_str(player_b_windwalk[id],TempSkill,10)
		add(itemEffect,199,"Press USEMAGIC to become invisble unable to attack and with incresed speed for ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," seconds.<br>")
	}
	
	if (player_b_reverse[id] > 0) 
	{
		num_to_str(player_b_reverse[id],TempSkill,10)
		add(itemEffect,199,"You have 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," chance to confuse the victim for %i seconds when you hit him<br>",player_b_reverse[id])
	}
	if (player_b_froglegs[id] > 0)
	{
		add(itemEffect,199,"You can hold down +DUCK 3 seconds to frogjump")
	}
	if (player_b_dagon[id] == 1)
	{
		add(itemEffect,199,"Press USEMAGIC to fire a lightning againt nearest opponent - you can upgrade this item with runes")
		add(itemEffect,199,"Also intelligence will give this item more range")
	}
	if (player_b_sniper[id] > 0) 
	{
		num_to_str(player_b_sniper[id],TempSkill,10)
		add(itemEffect,199,"You have 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," chance to instant kill with scout<br>")
	}
	if (player_b_jumpx[id] > 0)
	{
		num_to_str(player_b_jumpx[id],TempSkill,10)
		add(itemEffect,199,"You can jump ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," extra times in the air while pressing the jump button<br>")	
	}
	if (player_b_smokehit[id] > 0)
	{
		add(itemEffect,199,"Your Smokegrandes will kill instantly if they hit the opponent")
	}
	if (player_b_extrastats[id] > 0)
	{
		num_to_str(player_b_extrastats[id],TempSkill,10)
		add(itemEffect,199,"You gain +")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," to each stat while holding this item")
	}
	
	new Durability[10]
	num_to_str(item_durability[id],Durability,9)
	if (equal(itemEffect,"")) showitem(id,"None","None","Kill an enemy to recieve an item","None")
	if (!equal(itemEffect,"")) showitem(id,player_item_name[id],itemvalue,itemEffect,Durability)

}

/* ==================================================================================================== */

public award_item(id, itemnum)
{
	if (player_item_id[id] == 0)
	{
	
		set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		new rannum = random_num(1,51)
		
		new maxfind = player_agility[id]
		if (maxfind > 15) maxfind = 15
			
		new rf = random_num(1,25-maxfind)

		if (itemnum > 0) rannum = itemnum
		else if (itemnum < 0) return PLUGIN_HANDLED

		if (rf == 3 && itemnum == 0)						//We found a rare item			
		{
			award_unique_item(id)	
			rannum = -1
		}				

		if (rannum == 1)
		{
			player_item_name[id] = "Bronze Amplifier"
			player_item_id[id] = rannum
			player_b_damage[id] = random_num(1,3)
			show_hudmessage(id, "Item found: %s :: +%i damage",player_item_name[id],player_b_damage[id])
		}

		if (rannum == 2)
		{
			player_item_name[id] = "Silver Amplifier"
			player_item_id[id] = rannum
			player_b_damage[id] = random_num(3,6)
			show_hudmessage(id, "Item found: %s :: +%i damage",player_item_name[id],player_b_damage[id])
		}

		if (rannum == 3)
		{
			player_item_name[id] = "Gold Amplifier"
			player_item_id[id] = rannum
			player_b_damage[id] = random_num(6,10)
			show_hudmessage(id, "Item found: %s :: +%i damage",player_item_name[id],player_b_damage[id])	
		}
		if (rannum == 4)
		{
			player_item_name[id] = "Vampyric Staff"
			player_item_id[id] = rannum
			player_b_vampire[id] = random_num(1,4)
			show_hudmessage(id, "Item found: %s :: +%i vampyric damage",player_item_name[id],player_b_vampire[id])	
		}
		if (rannum == 5)
		{
			player_item_name[id] = "Vampyric Amulet"
			player_item_id[id] = rannum
			player_b_vampire[id] = random_num(4,6)
			show_hudmessage(id, "Item found: %s :: +%i vampyric damage",player_item_name[id],player_b_vampire[id])	
		}
		if (rannum == 6)
		{
			player_item_name[id] = "Vampyric Scepter"
			player_item_id[id] = rannum
			player_b_vampire[id] = random_num(6,9)
			show_hudmessage(id, "Item found: %s :: +%i vampyric damage",player_item_name[id],player_b_vampire[id])	
		}
		if (rannum == 7)
		{
			player_item_name[id] = "Small bronze bag"
			player_item_id[id] = rannum
			player_b_money[id] = random_num(150,500)
			show_hudmessage(id, "Item found: %s :: +%i money each round",player_item_name[id],player_b_money[id])	
		}
		if (rannum == 8)
		{
			player_item_name[id] = "Medium silver bag"
			player_item_id[id] = rannum
			player_b_money[id] = random_num(500,1200)
			show_hudmessage(id, "Item found: %s :: +%i money each round",player_item_name[id],player_b_money[id])	
		}
		if (rannum == 9)
		{
			player_item_name[id] = "Large gold bag"
			player_item_id[id] = rannum
			player_b_money[id] = random_num(1200,3000)
			show_hudmessage(id, "Item found: %s :: +%i money each round",player_item_name[id],player_b_money[id])	
		}
		if (rannum == 10)
		{
			player_item_name[id] = "Small angel wings"
			player_item_id[id] = rannum
			player_b_gravity[id] = random_num(4,9)
			show_hudmessage(id, "Item found: %s :: +%i gravity bonus",player_item_name[id],10-player_b_gravity[id])	
		}
		if (rannum == 11)
		{
			player_item_name[id] = "Arch angel wings"
			player_item_id[id] = rannum
			player_b_gravity[id] = random_num(1,4)
			show_hudmessage(id, "Item found: %s :: +%i gravity bonus",player_item_name[id],10-player_b_gravity[id])	
		}
		if (rannum == 12)
		{
			player_item_name[id] = "Invisibility Rope"
			player_item_id[id] = rannum
			player_b_inv[id] = random_num(150,200)
			show_hudmessage(id, "Item found: %s :: +%i invisibility bonus",player_item_name[id],255-player_b_inv[id])	
		}
		if (rannum == 13)
		{
			player_item_name[id] = "Invisibility Coat"
			player_item_id[id] = rannum
			player_b_inv[id] = random_num(110,150)
			show_hudmessage(id, "Item found: %s :: +%i invisibility bonus",player_item_name[id],255-player_b_inv[id])	
		}
		if (rannum == 14)
		{
			player_item_name[id] = "Invisibility Armor"
			player_item_id[id] = rannum
			player_b_inv[id] = random_num(70,110)
			show_hudmessage(id, "Item found: %s :: +%i invisibility bonus",player_item_name[id],255-player_b_inv[id])	
		}
		if (rannum == 15)
		{
			player_item_name[id] = "Firerope"
			player_item_id[id] = rannum
			player_b_grenade[id] = random_num(3,6)
			show_hudmessage(id, "Item found: %s :: +1/%i chance to instant HE kill",player_item_name[id],player_b_grenade[id])	
		}
		if (rannum == 16)
		{
			player_item_name[id] = "Fire Amulet"
			player_item_id[id] = rannum
			player_b_grenade[id] = random_num(2,4)
			show_hudmessage(id, "Item found: %s :: +1/%i chance to instant HE kill",player_item_name[id],player_b_grenade[id])	
		}
		if (rannum == 17)
		{
			player_item_name[id] = "Stalkers ring"
			player_item_id[id] = rannum
			player_b_reduceH[id] = 95
			player_b_inv[id] = 9
			set_user_health(id,5)
			show_hudmessage(id, "Item found: %s :: 5 health - knife and nearly invisible",player_item_name[id])	
		}
		if (rannum == 18)
		{
			player_item_name[id] = "Arabian Boots"
			player_item_id[id] = rannum
			player_b_theif[id] = random_num(500,1000)
			show_hudmessage(id, "Item found: %s :: 1/5 chance to steal $%i each time you hit",player_item_name[id],player_b_theif[id])	
		}
		if (rannum == 19)
		{
			player_item_name[id] = "Phoenix Ring"
			player_item_id[id] = rannum
			player_b_respawn[id] = random_num(3,6)
			show_hudmessage(id, "Item found: %s :: 1/%i chance to respawn upon death",player_item_name[id],player_b_respawn[id])	
		}
		if (rannum == 20)
		{
			player_item_name[id] = "Sorcerers ring"
			player_item_id[id] = rannum
			player_b_respawn[id] = random_num(2,3)
			show_hudmessage(id, "Item found: %s :: 1/%i chance to respawn upon death",player_item_name[id],player_b_respawn[id])	
		}
		if (rannum == 21)
		{
			player_item_name[id] = "Chaos Orb"
			player_item_id[id] = rannum
			player_b_explode[id] = random_num(150,275)
			show_hudmessage(id, "Item found: %s :: Explode in a radius of %i upon death",player_item_name[id],player_b_explode[id])	
		}
		if (rannum == 22)
		{
			player_item_name[id] = "Hell Orb"
			player_item_id[id] = rannum
			player_b_explode[id] = random_num(200,400)
			show_hudmessage(id, "Item found: %s :: Explode in a radius of %i upon death",player_item_name[id],player_b_explode[id])	
		}
		if (rannum == 23)
		{
			player_item_name[id] = "Gold statue"
			player_item_id[id] = rannum
			player_b_heal[id] = random_num(5,10)
			show_hudmessage(id, "Item found: %s :: Heals %i hp every 5 seconds",player_item_name[id],player_b_heal[id])	
		}
		if (rannum == 24)
		{
			player_item_name[id] = "Daylight Diamond"
			player_item_id[id] = rannum
			player_b_heal[id] = random_num(10,20)
			show_hudmessage(id, "Item found: %s :: Heals %i hp every 5 seconds",player_item_name[id],player_b_heal[id])	
		}
		if (rannum == 25)
		{
			player_item_name[id] = "Diamond Bracelet"
			player_item_id[id] = rannum
			player_b_heal[id] = random_num(20,35)
			show_hudmessage(id, "Item found: %s :: Heals %i hp every 5 seconds",player_item_name[id],player_b_heal[id])	
		}
		if (rannum == 26)
		{
			player_item_name[id] = "Wheel of Fortune"
			player_item_id[id] = rannum
			player_b_gamble[id] = random_num(2,3)
			show_hudmessage(id, "Item found: %s :: +%i to a random bonus each round",player_item_name[id],player_b_gamble[id])	
		}
		if (rannum == 27)
		{
			player_item_name[id] = "Four leaf Clover"
			player_item_id[id] = rannum
			player_b_gamble[id] = random_num(4,5)
			show_hudmessage(id, "Item found: %s :: +%i to a random bonus each round",player_item_name[id],player_b_gamble[id])	
		}
		if (rannum == 28)
		{
			player_item_name[id] = "Amulet of the sun"
			player_item_id[id] = rannum
			player_b_blind[id] = random_num(6,9)
			show_hudmessage(id, "Item found: %s :: 1/%i to blind the enemy when you damage him",player_item_name[id],player_b_blind[id])	
		}
		if (rannum == 29)
		{
			player_item_name[id] = "Sword of the sun"
			player_item_id[id] = rannum
			player_b_blind[id] = random_num(2,5)
			show_hudmessage(id, "Item found: %s :: 1/%i to blind the enemy when damaged",player_item_name[id],player_b_blind[id])	
		}
		if (rannum == 30)
		{
			player_item_name[id] = "Fireshield"
			player_item_id[id] = rannum
			player_b_fireshield[id] = 1
			show_hudmessage(id, "Item found: %s :: Protects against He instant kill and orbs",player_item_name[id],player_b_fireshield[id])	
		}
		if (rannum == 31)
		{
			player_item_name[id] = "Stealth Shoes"
			player_item_id[id] = rannum
			player_b_silent[id] = 1
			show_hudmessage(id, "Item found: %s :: Your run becomes silent",player_item_name[id])	
		}
		if (rannum == 32)
		{
			player_item_name[id] = "Meekstone"
			player_item_id[id] = rannum
			player_b_meekstone[id] = 1
			show_hudmessage(id, "Item found: %s :: USEMAGIC to lay fake bombs",player_item_name[id])	
		}
		if (rannum == 33)
		{
			player_item_name[id] = "Medicine Glar"
			player_item_id[id] = rannum
			player_b_teamheal[id] = random_num(10,20)
			show_hudmessage(id, "Item found: %s :: shoot at teammates to heal %i hp",player_item_name[id],player_b_teamheal[id])	
		}
		if (rannum == 34)
		{
			player_item_name[id] = "Medicine Totem"
			player_item_id[id] = rannum
			player_b_teamheal[id] = random_num(25,50)
			show_hudmessage(id, "Item found: %s :: shoot at teammates to heal %i hp",player_item_name[id],player_b_teamheal[id])	
		}
		if (rannum == 35)
		{
			player_item_name[id] = "Iron Armor"
			player_item_id[id] = rannum
			player_b_redirect[id] = random_num(3,6)
			show_hudmessage(id, "Item found: %s :: +%i Damage reduction",player_item_name[id],player_b_redirect[id])	
		}
		if (rannum == 36)
		{
			player_item_name[id] = "Mitril Armor"
			player_item_id[id] = rannum
			player_b_redirect[id] = random_num(6,11)
			show_hudmessage(id, "Item found: %s :: +%i Damage reduction",player_item_name[id],player_b_redirect[id])	
		}
		if (rannum == 37)
		{
			player_item_name[id] = "Godly Armor"
			player_item_id[id] = rannum
			player_b_redirect[id] = random_num(10,15)
			show_hudmessage(id, "Item found: %s :: +%i Damage reduction",player_item_name[id],player_b_redirect[id])	
		}
		if (rannum == 38)
		{
			player_item_name[id] = "Fireball staff"
			player_item_id[id] = rannum
			player_b_fireball[id] = random_num(50,100)
			show_hudmessage(id, "Item found: %s :: Will kill in a radius of %i",player_item_name[id],player_b_fireball[id])	
		}
		if (rannum == 39)
		{
			player_item_name[id] = "Fireball scepter"
			player_item_id[id] = rannum
			player_b_fireball[id] = random_num(100,200)
			show_hudmessage(id, "Item found: %s :: Will kill in a radius of %i",player_item_name[id],player_b_fireball[id])	
		}
		if (rannum == 40)
		{
			player_item_name[id] = "Ghost Rope"
			player_item_id[id] = rannum
			player_b_ghost[id] = random_num(3,6)
			show_hudmessage(id, "Item found: %s :: When activated you can walk through walls in %i sec",player_item_name[id],player_b_ghost[id])	
		}
		if (rannum == 41)
		{
			player_item_name[id] = "Nicolas eye"
			player_item_id[id] = rannum
			player_b_eye[id] = -1
			show_hudmessage(id, "Item found: %s :: USEMAGIC to place a camera and USEMAGIC again to use/stop",player_item_name[id])	
		}
		if (rannum == 42)
		{
			player_item_name[id] = "Primitive laser"
			player_item_id[id] = rannum
			player_b_railgun[id] = floatround(halflife_time())
			show_hudmessage(id, "Item found: %s :: Your knife is replaced with a railgun",player_item_name[id])	
		}
		if (rannum == 43)
		{
			player_item_name[id] = "Lothars Edge"
			player_item_id[id] = rannum
			player_b_windwalk[id] = random_num(4,7)
			show_hudmessage(id, "Item found: %s :: USEMAGIC to become invisible %i seconds unable to attack and with increased speed",player_item_name[id],player_b_windwalk[id])	
		}
		if (rannum == 44)
		{
			player_item_name[id] = "Staff of the Earth"
			player_item_id[id] = rannum
			player_b_reverse[id] = random_num(2,4)
			show_hudmessage(id, "Item found: %s :: 1/%i chance to confuse an opponent when you hit him",player_item_name[id],player_b_reverse[id])	
		}
		if (rannum == 45)
		{
			player_item_name[id] = "Magic Booster"
			player_item_id[id] = rannum
			player_b_froglegs[id] = 1
			show_hudmessage(id, "Item found: %s :: Hold down +DUCK 3 second to frog jump",player_item_name[id],player_b_reverse[id])	
		}
		if (rannum == 46)
		{
			player_item_name[id] = "Dagon I"
			player_item_id[id] = rannum
			player_b_dagon[id] = 1
			show_hudmessage(id, "Item found: %s :: Press USEMAGIC to fire a lightning against nearest opponent",player_item_name[id],player_b_reverse[id])	
		}
		if (rannum == 47)
		{
			player_item_name[id] = "Scout Extender"
			player_item_id[id] = rannum
			player_b_sniper[id] = random_num(3,4)
			show_hudmessage(id, "Item found: %s :: 1/%i chance to instant kill with scout",player_item_name[id],player_b_sniper[id])	
		}
		if (rannum == 48)
		{
			player_item_name[id] = "Scout Amplifier"
			player_item_id[id] = rannum
			player_b_sniper[id] = random_num(2,3)
			show_hudmessage(id, "Item found: %s :: 1/%i chance to instant kill with scout",player_item_name[id],player_b_sniper[id])	
		}
		if (rannum == 49)
		{
			player_item_name[id] = "Air booster"
			player_item_id[id] = rannum
			player_b_jumpx[id] = 1
			show_hudmessage(id, "Item found: %s :: You can now double-jump",player_item_name[id],player_b_sniper[id])	
		}
		if (rannum == 50)
		{
			player_item_name[id] = "Iron Spikes"
			player_item_id[id] = rannum
			player_b_smokehit[id] = 1
			show_hudmessage(id, "Item found: %s :: If you hit anyone directly with your smoke grenades they will die",player_item_name[id])	
		}
		if (rannum == 51)
		{
			player_item_name[id] = "Point Booster"
			player_item_id[id] = rannum
			player_b_extrastats[id] = random_num(1,3)
			BoostStats(id,player_b_extrastats[id])
			show_hudmessage(id, "Item found: %s :: You gain +%i to each skill while wearing this item",player_item_name[id],player_b_extrastats[id])	
		}
		
		//Set durability, make this item dependant?
		item_durability[id] = 250
		
		
		
	}
	
	return PLUGIN_CONTINUE
}

/* UNIQUE ITEMS ============================================================================================ */
//Names are generated from an array

public award_unique_item(id)
{
	new Unique_names_Suffix[10][100]
	new Unique_names_Prefix[10][100]

	Unique_names_Suffix[1] = "Saintly amulet "
	Unique_names_Suffix[2] = "Holy sword "
	Unique_names_Suffix[3] = "Small staff "
	Unique_names_Suffix[4] = "Bright rope "
	Unique_names_Suffix[5] = "Shiny scepter "

	Unique_names_Prefix[1] = "of the stars"
	Unique_names_Prefix[2] = "of power"
	Unique_names_Prefix[3] = "of zod"
	Unique_names_Prefix[4] = "of life"
	Unique_names_Prefix[5] = "of the sun"

	//Generate the items name

	new roll_1 = random_num(1,4)
	new roll_2 = random_num(1,4)

	new Unique_name[100]
	add(Unique_name,99,Unique_names_Suffix[roll_1])
	add(Unique_name,99,Unique_names_Prefix[roll_2])

	player_item_name[id] = Unique_name
	player_item_id[id] = 100				
	
	//Generate and apply the stats

	if (roll_1 == 1) player_b_damage[id] = random_num(1,5)
	if (roll_1 == 2) player_b_vampire[id] = random_num(1,5)
	if (roll_1 == 3) player_b_money[id] = random_num(2500,5000)
	if (roll_1 == 4) player_b_reduceH[id] = random_num(20,50)
	if (roll_1 == 5) player_b_blind[id] = random_num(3,5)



	if (roll_2 == 1) player_b_grenade[id] = random_num(1,4)
	if (roll_2 == 2) player_b_respawn[id] = random_num(2,4)
	if (roll_2 == 3) player_b_explode[id] = random_num(150,400)
	if (roll_2 == 4) player_b_redirect[id] = random_num(5,10)
	if (roll_2 == 5) player_b_heal[id] = random_num(1,15)
	
	item_durability[id] = 350

	set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
	show_hudmessage(id, "Uniqie Item found: %s", Unique_name)

}
/* EFFECTS ================================================================================================= */

public add_damage_bonus(id,damage,attacker_id)
{
	if (player_b_damage[attacker_id] > 0)
	{
		if (get_user_health(id) > player_b_damage[attacker_id])
		{
			set_user_health(id,get_user_health(id) - player_b_damage[attacker_id])
		} 
		else 
		{
			set_user_health(id,random_num(1,5))
		}
	}
}

/* ==================================================================================================== */

public add_vampire_bonus(id,damage,attacker_id)
{
	if (player_b_vampire[attacker_id] > 0)
	{
		new maxhealth = 100+player_strength[attacker_id]

		
		if (get_user_health(attacker_id)+player_b_vampire[attacker_id] <= maxhealth)
		{
			set_user_health(attacker_id,get_user_health(attacker_id)+player_b_vampire[attacker_id])
		} 
		else 
		{
			set_user_health(attacker_id,maxhealth)
		}
	}
}

/* ==================================================================================================== */

public add_money_bonus(id)
{
	if (player_b_money[id] > 0)
	{
		if (cs_get_user_money(id) < 16000 - player_b_money[id]) 
		{
			cs_set_user_money(id,cs_get_user_money(id)+ player_b_money[id]) 
		} 
		else 
		{
			cs_set_user_money(id,16000)
		}
	}
}

/* ==================================================================================================== */

public add_gravity_bonus(id)
{
	if (player_b_gravity[id] > 0)
	{
		if (player_b_gravity[id] > 6)
		{
			set_user_gravity(id,0.8)		
		}
		if (player_b_gravity[id] > 4)
		{
			set_user_gravity(id,0.6)		
		}
		if (player_b_gravity[id] >= 1)
		{
			set_user_gravity(id,0.4)		
		}
	}
}

/* ==================================================================================================== */

public add_inv_bonus(id)
{
	if (player_b_inv[id] > 0)
	{
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,player_b_inv[id])
	}
}

/* ==================================================================================================== */

public add_grenade_bonus(id,attacker_id,weapon)
{
	if (player_b_grenade[attacker_id] > 0 && weapon == 4 && player_b_fireshield[id] == 0)	//Fireshield check
	{
		new roll = random_num(1,player_b_grenade[attacker_id])
		if (roll == 1)
		{
			set_user_health(id, 0)
			message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
			write_byte(attacker_id) 
			write_byte(id) 
			write_byte(0) 
			write_string("grenade") 
			message_end() 
			set_user_frags(attacker_id, get_user_frags(attacker_id)+1) 
			set_user_frags(id, get_user_frags(id)+1)
			cs_set_user_money(attacker_id, cs_get_user_money(attacker_id)+150) 
		}
	}
}

/* ==================================================================================================== */

public add_redhealth_bonus(id)
{
	if (player_b_reduceH[id] > 0)
	{
		set_user_health(id,100-player_b_reduceH[id])
	}
}

/* ==================================================================================================== */

public add_theif_bonus(id,attacker_id)
{
	if (player_b_theif[attacker_id] > 0)
	{
		new roll1 = random_num(1,5)
		if (roll1 == 1)
		{
			if (cs_get_user_money(id) > player_b_theif[attacker_id])
			{
				cs_set_user_money(id,cs_get_user_money(id)-player_b_theif[attacker_id])
				if (cs_get_user_money(attacker_id) + player_b_theif[attacker_id] <= 16000)
				{
					cs_set_user_money(attacker_id,cs_get_user_money(id)+player_b_theif[attacker_id])		
				}
			}
			else
			{
				new allthatsleft = cs_get_user_money(id)
				cs_set_user_money(id,0)
				if (cs_get_user_money(attacker_id) + allthatsleft <= 16000)
				{
					cs_set_user_money(attacker_id,cs_get_user_money(id) + allthatsleft)			
				}
			}
		}
	}
}

/* ==================================================================================================== */

public add_respawn_bonus(id)
{
	if (player_b_respawn[id] > 0)
	{
		new svIndex[32] 
		num_to_str(id,svIndex,32)
		new roll = random_num(1,player_b_respawn[id])
		if (roll == 1)
		{
			new maxpl,players[32]
			get_players(players, maxpl) 
			if (maxpl > 2)
			{
				cs_set_user_money(id,cs_get_user_money(id)+4000)
				set_task(0.5,"respawn",0,svIndex,32) 		
			}
			else
			{
				set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "More than 2 players required for a succesfull respawn")	
			}
			
		}
	}
}

public respawn(svIndex[]) 
{ 
	new vIndex = str_to_num(svIndex) 
	spawn(vIndex);
}

/* ==================================================================================================== */

public add_bonus_explode(id)
{
	if (player_b_explode[id] > 0)
	{
		new origin[3] 
		get_user_origin(id,origin) 
		explode(origin,id,0)
		for(new a = 0; a < MAX; a++) 
		{ 
			if (is_user_connected(a))
			{				
				new origin1[3]
				get_user_origin(a,origin1) 
				if(is_user_alive(a)  && player_b_fireshield[a] == 0)		//Fireshield check
				{
					if(get_distance(origin,origin1) < player_b_explode[id] + player_intelligence[id]*2 && get_user_team(a) != get_user_team(id))
					{
						UTIL_Kill(id,a,"grenade")	
					}
				}
			}
		}
	}
}

public explode(vec1[3],playerid, trigger)
{ 
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
	write_byte( 21 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2] + 32) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2] + 1000)
	write_short( white ) 
	write_byte( 0 ) 
	write_byte( 0 ) 
	write_byte( 3 ) 
	write_byte( 10 ) 
	write_byte( 0 ) 
	write_byte( 188 ) 
	write_byte( 220 ) 
	write_byte( 255 ) 
	write_byte( 255 ) 
	write_byte( 0 ) 
	message_end() 

	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte( 12 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_byte( 188 ) 
	write_byte( 10 ) 
	message_end() 

	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
	write_byte( 3 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_short( fire ) 
	write_byte( 65 ) 
	write_byte( 10 ) 
	write_byte( 0 ) 
	message_end() 

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY,{0,0,0},playerid) 
	write_byte(107) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_coord(175) 
	write_short (gibs) 
	write_short (25)  
	write_byte (10) 
	message_end() 
	if (trigger == 1)
	{
		set_user_rendering(playerid,kRenderFxNone, 0,0,0, kRenderTransAdd,0) 
	}
}

/* ==================================================================================================== */

public add_bonus_gamble(id)
{	
	if (player_b_gamble[id] > 0)
	{
		reset_item_skills(id)
		set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		new roll = random_num(1,player_b_gamble[id])
		if (roll == 1)
		{
			show_hudmessage(id, "Round bonus: +5 damage")
			player_b_damage[id] = 5
		}
		if (roll == 2)
		{
			show_hudmessage(id, "Round bonus: +5 Gravity bonus")
			player_b_gravity[id] = 5
		}
		if (roll == 3)
		{
			show_hudmessage(id, "Round bonus: +5 vampyric damage")
			player_b_vampire[id] = 5
		}
		if (roll == 4)
		{
			show_hudmessage(id, "Round bonus: +10 Heal bonus every 5 seconds")
			player_b_heal[id] = 10
		}
		if (roll == 5)
		{
			show_hudmessage(id, "Round bonus: 1/3 chance to instant HE kill")
			player_b_grenade[id] = 3
		}
	}
}

/* ==================================================================================================== */

public add_bonus_blind(id,attacker_id,weapon,damage)
{
	if (player_b_blind[attacker_id] > 0 && weapon != 4)
	{
		new roll = random_num(1,player_b_blind[attacker_id])
		if (roll == 1)
		{
			message_begin(MSG_ONE,gmsgFade,{0,0,0},id)
			write_short( 1<<14 ) 
			write_short( 1<<14 ) 
			write_short( 1<<16 ) 
			write_byte( 255 ) 
			write_byte( 155 ) 
			write_byte( 50 ) 
			write_byte( 230 ) 
			message_end()
		}

	}
}

/* ==================================================================================================== */

public item_c4fake(id)
{ 
	if (player_b_meekstone[id] > 0 && c4state[id] == 1 && is_user_alive(id) == 1 && freeze_ended == true)
	{
		explode(c4bombc[id],id,0)

		for(new a = 0; a < MAX; a++) 
		{ 
			if (is_user_connected(a) && is_user_alive(a))
			{			
				new origin1[3]
				get_user_origin(a,origin1) 

				if(get_distance(c4bombc[id],origin1) < 300 && get_user_team(a) != get_user_team(id))
				{
					UTIL_Kill(id,a,"grenade")
				}
			}
		}
			
		c4state[id] = 2
		remove_entity(c4fake[id])
		c4fake[id] = 0 
	}

	if (player_b_meekstone[id] > 0 && c4state[id] == 0 && c4fake[id] == 0 && is_user_alive(id) == 1 && freeze_ended == true)
	{
		new Float:pOrigin[3]
		entity_get_vector(id,EV_VEC_origin, pOrigin)
		c4fake[id] = create_entity("info_target")
		
		entity_set_model(c4fake[id],"models/w_backpack.mdl")
		entity_set_origin(c4fake[id],pOrigin)
		entity_set_string(c4fake[id],EV_SZ_classname,"fakec4")
		entity_set_edict(c4fake[id],EV_ENT_owner,id)
		entity_set_int(c4fake[id],EV_INT_movetype,6)
		
		
		new Float:aOrigin[3]
		entity_get_vector(c4fake[id],EV_VEC_origin, aOrigin)
		c4bombc[id][0] = floatround(aOrigin[0])
		c4bombc[id][1] = floatround(aOrigin[1])
		c4bombc[id][2] = floatround(aOrigin[2])
		c4state[id] = 1
	}

	return PLUGIN_CONTINUE 
}

/* ==================================================================================================== */

public item_fireball(id)
{
	if (fired[id] == 0 && player_b_fireball[id] > 0 && is_user_alive(id) == 1 && freeze_ended == true)
	{
		fired[id] = 1
		new Float:vOrigin[3]
		new fEntity
		entity_get_vector(id,EV_VEC_origin, vOrigin)
		fEntity = create_entity("info_target")
		entity_set_model(fEntity, "models/rpgrocket.mdl")
		entity_set_origin(fEntity, vOrigin)
		entity_set_int(fEntity,EV_INT_effects,64)
		entity_set_string(fEntity,EV_SZ_classname,"fireball")
		entity_set_int(fEntity,EV_INT_movetype,5)
		entity_set_edict(fEntity,EV_ENT_owner,id)
		
		//Send forward
		new Float:fl_iNewVelocity[3]
		VelocityByAim(id, 400, fl_iNewVelocity)
		entity_set_vector(fEntity, EV_VEC_velocity, fl_iNewVelocity)
	
	
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
		write_byte(22) 
		write_short(fEntity) 
		write_short(beam) 
		write_byte(45) 
		write_byte(4) 
		write_byte(255) 
		write_byte(0) 
		write_byte(0) 
		write_byte(25)
		message_end() 
	}	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_teamheal(id)
{
	if (player_b_teamheal[id] > 0)
	{
		new enemy, body
		get_user_aiming(id,enemy,body)
		if (0<enemy<=32 && get_user_team(id) == get_user_team(enemy))
		{
			if (get_user_health(enemy) + player_b_teamheal[id] <= 100)
			{
				set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Player Healed")
				set_user_health(enemy,get_user_health(enemy) + player_b_teamheal[id])
			}
			else
			{
				set_user_health(enemy,100)
			}
		}
	}
}

/* ==================================================================================================== */

public add_bonus_redirect(id)
{
	if (player_b_redirect[id] > 0)
	{
		if (get_user_health(id)+player_b_redirect[id] <= 100)
		{
			set_user_health(id,get_user_health(id)+player_b_redirect[id])
		}
			
	}
}

/* ==================================================================================================== */

public item_ghost(id)
{
	if (ghoststate[id] == 0 && player_b_ghost[id] > 0 && is_user_alive(id) == 1 && freeze_ended == true && ghost_check == false)
	{
		set_user_noclip(id,1)
		ghoststate[id] = 1
		if (ghost_check == false) ghost_check = true
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( player_b_ghost[id]+1 ) 
		write_byte( 0 ) 
		message_end() 
	}
	else
	{
		set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "Only one player can use the ghost ability at one time or item already used")
	}
}

/* ==================================================================================================== */

public add_strength_bonus(id)
{
	set_user_health(id,100+player_strength[id]*2)
}

/* ==================================================================================================== */

public item_eye(id)
{
	if (player_b_eye[id] == -1)
	{
		//place camera
		new Float:playerOrigin[3]
		entity_get_vector(id,EV_VEC_origin,playerOrigin)
		new ent = create_entity("info_target") 
		entity_set_string(ent, EV_SZ_classname, "PlayerCamera") 
		entity_set_int(ent, EV_INT_movetype, MOVETYPE_NOCLIP) 
		entity_set_int(ent, EV_INT_solid, SOLID_NOT) 
		entity_set_edict(ent, EV_ENT_owner, id)
		entity_set_model(ent, "models/rpgrocket.mdl")  				//Just something
		entity_set_origin(ent,playerOrigin)
		entity_set_int(ent,EV_INT_iuser1,0)		//Viewing through this camera						
		set_rendering (ent,kRenderFxNone, 0,0,0, kRenderTransTexture,0)
		entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 
		player_b_eye[id] = ent
	}
	else
	{
		//view through camera or stop viewing
		new ent = player_b_eye[id]
		if (!is_valid_ent(ent))
		{
			attach_view(id,id)
			return PLUGIN_HANDLED
		}
		new viewing = entity_get_int(ent,EV_INT_iuser1)

		if (viewing) 
		{	
			entity_set_int(ent,EV_INT_iuser1,0)
			attach_view(id,id)
		}	
		else 
		{
			entity_set_int(ent,EV_INT_iuser1,1)
			attach_view(id,ent)
		}
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

//Called when PlayerCamera thinks
public Think_PlayerCamera(ent)
{
	new id = entity_get_edict(ent,EV_ENT_owner)
	
	//Check if player is still having the item and is still online
	if (!is_valid_ent(id) || player_b_eye[id] == 0 || !is_user_connected(id))
	{
		//remove entity
		if (is_valid_ent(id) && is_user_connected(id)) attach_view(id,id)
		remove_entity(ent)
	}
	else
	{
		//Dont use cpu when not alive anyway or not viewing
		if (!is_user_alive(id))
		{
			entity_set_float(ent,EV_FL_nextthink,halflife_time() + 3.0) 
			return PLUGIN_HANDLED
		}
		
		if (!entity_get_int(ent,EV_INT_iuser1))
		{
			entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.5) 
			return PLUGIN_HANDLED
		}
		
		entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 
		
		//Find nearest player to camera
		new Float:pOrigin[3],Float:plOrigin[3],Float:ret[3]
		entity_get_vector(ent,EV_VEC_origin,plOrigin)
		new Float:distrec = 2000.0, winent = -1
	
		for (new i=0; i<MAX; i++) 
		{
			if (is_user_connected(i) && is_user_alive(i))
			{
				entity_get_vector(i,EV_VEC_origin,pOrigin)
				pOrigin[2]+=10.0
				if (trace_line ( 0, plOrigin, pOrigin, ret ) == i && vector_distance(pOrigin,plOrigin) < distrec)
				{
					winent = i
					distrec = vector_distance(pOrigin,plOrigin)
				}
			}	
		}
		
		//Traceline and updown is still revresed
		if (winent > -1)
		{
			new Float:toplayer[3], Float:ideal[3],Float:pOrigin[3]
			entity_get_vector(winent,EV_VEC_origin,pOrigin)
			pOrigin[2]+=10.0
			toplayer[0] = pOrigin[0]-plOrigin[0]
			toplayer[1] = pOrigin[1]-plOrigin[1]
			toplayer[2] = pOrigin[2]-plOrigin[2]
			vector_to_angle ( toplayer, ideal ) 
			ideal[0] = ideal[0]*-1
			entity_set_vector(ent,EV_VEC_angles,ideal)
		}
	}
	
	return PLUGIN_CONTINUE
}

public Create_Line(id,origin1[3],origin2[3],bool:draw)
{
	if (draw)
	{
		message_begin(MSG_ONE,SVC_TEMPENTITY,{0,0,0},id)
		write_byte(0)
		write_coord(origin1[0])	// starting pos
		write_coord(origin1[1])
		write_coord(origin1[2])
		write_coord(origin2[0])	// ending pos
		write_coord(origin2[1])
		write_coord(origin2[2])
		write_short(line)	// sprite index
		write_byte(1)		// starting frame
		write_byte(5)		// frame rate
		write_byte(2)		// life
		write_byte(3)		// line width
		write_byte(0)		// noise
		write_byte(255)	// RED
		write_byte(50)	// GREEN
		write_byte(50)	// BLUE					
		write_byte(155)		// brightness
		write_byte(5)		// scroll speed
		message_end()
	}
	
	new Float:ret[3],Float:fOrigin1[3],Float:fOrigin2[3]
	//So we dont hit ourself
	origin1[2]+=50
	IVecFVec(origin1,fOrigin1)
	IVecFVec(origin2,fOrigin2)
	new hit = trace_line ( 0, fOrigin1, fOrigin2, ret )
	return hit

}

/* ==================================================================================================== */

public Setup_Railgun(id)
{
	entity_set_string(id, EV_SZ_viewmodel, "addons/amxmodx/diablo/v_deagle.mdl")
	entity_set_string(id, EV_SZ_weaponmodel, "addons/amxmodx/diablo/p_deagle.mdl")
}

public Reset_Railgun(id)
{
	new viewmodel[40]
	entity_get_string(id,EV_SZ_viewmodel,viewmodel,39)
	
	if (equal(viewmodel,"addons/amxmodx/diablo/v_deagle.mdl"))
	{
		
		entity_set_string(id, EV_SZ_viewmodel, "models/v_knife.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/p_knife.mdl")
	}
}
public Prethink_railgun(id)
{
	if( get_user_button(id) & IN_ATTACK && !(get_user_oldbutton(id) & IN_ATTACK) && is_user_alive(id)) 
	{			
		new clip, ammo
		new weapon = get_user_weapon(id,clip,ammo)
				
		if (weapon == CSW_KNIFE)
		{
			if (halflife_time()-player_b_railgun[id] <= 2) return PLUGIN_HANDLED
				
			player_b_railgun[id] = floatround(halflife_time())
			new origin1[3],origin2[3]
			get_user_origin(id,origin1,1)
			get_user_origin(id,origin2,3)
			new hit = Create_Line(id,origin1,origin2,true)
					
			if (hit > 0 && is_user_alive(hit) && get_user_team(hit) != get_user_team(id)) 
			{
				set_user_frags(id,get_user_frags(id)+1)
				award_xp(id,hit)
				user_kill(hit,1) 
				message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
				write_byte(id) 
				write_byte(hit) 
				write_byte(0) 
				write_string("world") 
				message_end() 
			}			
		}
	}
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */


//Called on end or mapchange -- Save items for players
public plugin_end() 
{
	new Datafile[64], amxbasedir[64]
	//build_path(Datafile,63,"$basedir/diablo/datafile.txt") 
	
	get_basedir(amxbasedir,63)
	format(Datafile,63,"%s/diablo/datafile.txt",amxbasedir)
	
	if(file_exists(Datafile)) delete_file(Datafile)
	
	//Write name and item for each player
	for (new i=0; i < MAX; i++)
	{
		if (player_dc_item[i] > 0 && player_dc_item[i] != 100) //unique
		{
			new data[100]
			format(data,99,"%s^"%i^"",player_dc_name[i],player_dc_item[i])
			write_file(Datafile,data)
		}
	}
}

/* ==================================================================================================== */

public handle_mapchange(id)
{
	if (!itemrestore) 
		return PLUGIN_HANDLED
	
	if (!updatedtable)
		updateitemtable()
	
	new currentname[50]
	get_user_name(id,currentname,50)
	
	for (new i=0; i < MAX; i++)
	{
		if (player_c_item[i] > 0)
		{
			if (equal(currentname,player_c_name[i]))
				award_item(id,player_c_item[i])
		}
	}
				
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public DisableItemRestore()
{
	itemrestore = false
}

/* ==================================================================================================== */

public updateitemtable()
{
	if (get_cvar_num("diablo_saveitems") == 0)
		return PLUGIN_HANDLED
		
	new Datafile[64], amxbasedir[64]
	
	get_basedir(amxbasedir,63)
	format(Datafile,63,"%s/diablo/datafile.txt",amxbasedir)
	
	
	if(file_exists(Datafile)) 
	{
		new linenum = 0
		new linedata[100]
		new readlen = 0
		while (read_file ( Datafile, linenum, linedata, 99, readlen ) != 0)
		{
			linenum++
			
			if (linenum > MAX+1)
			{
				//More entries than players, abort
				log_amx("More than %i entries in Datafile, aborting table update",linenum)
				return PLUGIN_HANDLED
			}
			
			new linebreak = contain ( linedata, "^"" )
			
			if (strlen(linedata) < linebreak+1)
				continue
				
			new itembreak = contain (linedata[linebreak+1], "^"")
			
			if (linebreak > -1 && itembreak > -1)
			{

				new name[50]
				new item[50]
				
				copyc ( name, linebreak, linedata, '"' ) 
				copyc ( item, itembreak, linedata[linebreak+1],'"')
				
				player_c_name[linenum-1] = name
				player_c_item[linenum-1] = str_to_num(item)	
			}
		}
		
		updatedtable = true
	}
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public item_windwalk(id)
{
	//First time this round
	if (player_b_usingwind[id] == 0)
	{
		new szId[10]
		num_to_str(id,szId,9)
		player_b_usingwind[id] = 1
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,75)
		engclient_cmd(id,"weapon_knife") 
		set_user_maxspeed(id,500.0)

		new Float:val = player_b_windwalk[id] + 0.0
		set_task(val,"resetwindwalk",0,szId,32) 
		
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( player_b_windwalk[id]) 
		write_byte( 0 ) 
		message_end() 
	}
	
	//Disable again
	else if (player_b_usingwind[id] == 1)
	{
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
		player_b_usingwind[id] = 2
		set_user_maxspeed(id,270.0)
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( 0) 
		write_byte( 0 ) 
		message_end() 
	}
	
	//Already used
	else if (player_b_usingwind[id] == 2)
	{
		set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "You can only use this item once a turn") 
	}
	
}

public resetwindwalk(szId[])
{
	new id = str_to_num(szId)
	if (id < 0 || id > MAX)
	{
		log_amx("Error in resetwindwalk, id: %i out of bounds", id)
	}
	
	if (player_b_usingwind[id] == 1)
	{
		player_b_usingwind[id] = 2
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)	
		set_user_maxspeed(id,270.0)
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( 0) 
		write_byte( 0 ) 
		message_end() 
	}
	
}

/* ==================================================================================================== */

public Prethink_usingwind(id)
{
	
	if( get_user_button(id) & IN_ATTACK && is_user_alive(id))
	{
		new buttons = pev(id,pev_button)
		set_pev(id,pev_button,(buttons & ~IN_ATTACK));
		return FMRES_HANDLED;	
	}
	
	if( get_user_button(id) & IN_ATTACK2 && is_user_alive(id))
	{
		new buttons = pev(id,pev_button)
		set_pev(id,pev_button,(buttons & ~IN_ATTACK2));
		return FMRES_HANDLED;	
	}
		
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public add_bonus_confuse(id,attacker_id)
{
	if (player_b_reverse[attacker_id] > 0 && !is_user_bot(id) && player_b_oldsen[id] == 0.0)
	{
		if (random_num(1,player_b_reverse[attacker_id]) == 1)
		{
			//Confuse the victim
			query_client_cvar(id, "sensitivity", "cvar_result_func"); 
			
			
			message_begin( MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id ) 
			write_byte( 1 )     
			write_string( "dmg_chem") 
			write_byte( 100 ) // red 
			write_byte( 100 ) // green 
			write_byte( 100 ) // blue 
			message_end()  
			
		}
			
	}
}

public cvar_result_func(id, const cvar[], const value[]) 
{ 
	player_b_oldsen[id] = str_to_float(value)
	new svIndex[32] 
	num_to_str(id,svIndex,32)
	set_task(2.5,"resetsens",0,svIndex,32) 		
		
		
}

public resetsens(svIndex[]) 
{ 
	new id = str_to_num(svIndex) 
	
	if (player_b_oldsen[id] > 0.0)
	{
		client_cmd(id,"sensitivity %f",player_b_oldsen[id])
		player_b_oldsen[id] = 0.0
	}
	
	message_begin( MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id ) 
	write_byte( 0 )     
	write_string( "dmg_chem") 
	write_byte( 100 ) // red 
	write_byte( 100 ) // green 
	write_byte( 100 ) // blue 
	message_end()  
	
	
} 


/* ==================================================================================================== */

public Prethink_confuseme(id)
{
	if (player_b_oldsen[id] > 0.0)
		client_cmd(id,"sensitivity %f", 100.0)
	
}

/* ==================================================================================================== */

public Findleader()
{
	//Finds a leader for both teams
	new numCT, numT, IDSCT[MAX], IDST[MAX]
	
	for (new i=0; i < MAX; i++)
	{
		if (is_user_connected(i) && is_user_alive(i))
		{
			new team[32]
			get_user_team(i,team,31)
			if (equal(team,"TERRORIST"))
			{
				IDST[numT] = i
				numT++
			}
			else if (equal(team,"CT"))
			{
				IDSCT[numCT] = i
				numCT++
			}
		}
	}
		
	LeaderCT = IDSCT[random_num(0,numCT)]
	LeaderT = IDST[random_num(0,numT)]
	
	//PowerUp system takes Position from leader as basic
	if (is_user_connected(LeaderCT) && is_user_connected(LeaderT))
	{
		get_user_origin(LeaderCT,CTstart,0)
		get_user_origin(LeaderT,Tstart,0)
		spawnset = true
	}
	
	set_hudmessage(60, 100, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
	show_hudmessage(LeaderCT, "You are selected as leader. You and your teammates will get extra xp while you're alive") 
	show_hudmessage(LeaderT, "You are selected as leader. You and your teammates will get extra xp while you're alive") 
	
}

/* ==================================================================================================== */

public Bot_Dropitem()
{
	for (new id=0; id < MAX; id++)
	{
		if (is_user_connected(id) && is_user_bot(id))
		{
			if (random_num(1,3) == 1 && player_item_id[id] > 0)
				client_cmd(id,"say /dropitem")
		}
	}
}

/* ==================================================================================================== */

public host_killed(id)
{
	if (player_xp[id]-get_cvar_num("diablo_xpbonus") < calc_xp(player_lvl[id]-1))
	{
		player_xp[id] = calc_xp(player_lvl[id]-1)
	}
	else
	{
		player_xp[id]-=get_cvar_num("diablo_xpbonus")
	}
}


/* ==================================================================================================== */
	
public showmenu(id)
{
	new text[513] 
	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)


	format(text, 512, "\yOptions - ^n\w1. Item Information^n\w2. Drop Current Item^n\w3. Show Help^n\w4. Use items ultimate^n\w5. Buy Rune^n\w6. Skills Information^n\w7. Exit") 

	show_menu(id, keys, text) 
	return PLUGIN_HANDLED  
} 


public option_menu(id, key) 
{ 
	switch(key) 
	{ 
		case 0: 
		{	
			iteminfo(id)
			
		}
		case 1: 
		{	
			dropitem(id)
		}
		case 2: 
		{	
			helpme(id)
		}
		case 3:
		{
			check_magic(id)
		}
		case 4:
		{
			buyrune(id)
		}
		case 5:
		{
			showskills(id)
		}
		case 6:
		{
			return PLUGIN_HANDLED
		}
	}

	return PLUGIN_HANDLED
}

public Prethink_froglegs(id)
{
	if (get_user_button(id) & IN_DUCK)
	{
		//start holding down button here, set to halflife time
		if (player_b_froglegs[id] == 1) 
		{
			player_b_froglegs[id] = floatround(halflife_time())
		}
		else
		{
			if (floatround(halflife_time())-player_b_froglegs[id] >= 2.0)
			{
				new Float:fl_iNewVelocity[3]
				VelocityByAim(id, 1000, fl_iNewVelocity)
				fl_iNewVelocity[2] = 210.0
				entity_set_vector(id, EV_VEC_velocity, fl_iNewVelocity)
				player_b_froglegs[id] = 1
			}
		}
	}
	else
	{
		player_b_froglegs[id] = 1
	}
}

/* ==================================================================================================== */

public select_class(id)
{
	new text[513] 
	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)

	format(text, 512, "\ySelect Class - ^n\w1. Sorcerer [Spells are more powerfull]^n\w2. Paladin [Bonus to strength]^n\w3. Monk [More Experienced gained]^n\w4. Assassin [Faster and no footsteps]^n\w5. Barbarian [Regain hitpoint upon kill]^n\w6. Necromancer [Returns some of the damage taken]") 

	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)
	show_menu(id, keys, text) 
	return PLUGIN_HANDLED  
} 


public select_class_menu(id, key) 
{ 
	switch(key) 
	{ 
		case 0: 
		{	
			player_class[id] = SORC
			
		}
		case 1: 
		{	
			player_class[id] = PALADIN
			player_strength[id]+=4
		}
		case 2: 
		{	
			player_class[id] = MONK
		}
		case 3: 
		{	
			player_class[id] = ASSASSIN
		}
		case 4: 
		{	
			player_class[id] = BARBARIAN
		}
		case 5: 
		{	
			player_class[id] = NECROMANCER
		}
	}

	if (player_class[id] == 0) select_class(id)
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_barbarian_bonus(id)
{
	if (player_class[id] == BARBARIAN)
	{	
		new maxhealth = 100+player_strength[id]

		
		if (get_user_health(id)+50 <= maxhealth)
		{
			set_user_health(id,get_user_health(id)+50)
		} 
		else 
		{
			set_user_health(id,maxhealth)
		}
	}
}

/* ==================================================================================================== */

public add_bonus_necromancer(attacker_id,id)
{
	if (player_class[attacker_id] == NECROMANCER)
	{
		if (get_user_health(id) - 10 <= 0)
		{
			set_user_health(id,random_num(1,3))
		}
		else
		{
			set_user_health(id,get_user_health(id)-10)
		}
	}
}

/* ==================================================================================================== */

//What modules are required
public plugin_modules()
{
	require_module("engine")
	require_module("cstrike")
	require_module("fun")
	require_module("fakemeta")
}

/* ==================================================================================================== */

//Find the nearest alive opponent in our view
public UTIL_FindNearestOpponent(id,maxdist)
{
	new best = 99999
	new entfound = -1
	new MyOrigin[3]
	get_user_origin(id,MyOrigin)
	
	for (new i=1; i < MAX; i++)
	{
		if (i == id || !is_user_connected(i) || !is_user_alive(i) || get_user_team(id) == get_user_team(i))
			continue
			
		new TempOrigin[3],Float:fTempOrigin[3]
		get_user_origin(i,TempOrigin)
		IVecFVec(TempOrigin,fTempOrigin)
		
		if (!UTIL_IsInView(id,i))
			continue
		
		
		new dist = get_distance ( MyOrigin,TempOrigin ) 
		
		if ( dist < maxdist && dist < best)
		{
			best = dist
			entfound = i
		}		
	}
	
	return entfound
}

/* ==================================================================================================== */

//Basicly see's if we can draw a straight line to the target without interference
public bool:UTIL_IsInView(id,target)
{
	new Float:IdOrigin[3], Float:TargetOrigin[3], Float:ret[3] 
	new iIdOrigin[3], iTargetOrigin[3]
	
	get_user_origin(id,iIdOrigin,1)
	get_user_origin(target,iTargetOrigin,1)
	
	IVecFVec(iIdOrigin,IdOrigin)
	IVecFVec(iTargetOrigin, TargetOrigin)
		
	if ( trace_line ( 1, IdOrigin, TargetOrigin, ret ) == target)
		return true
		
	if ( get_distance_f(TargetOrigin,ret) < 10.0)
		return true
	
	return false

}
/* ==================================================================================================== */

public item_dagon(id)
{
	if (player_b_dagfired[id])
	{
		set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "You can only use this item once a turn") 
		return PLUGIN_HANDLED
	}
	//Target nearest non-friendly player
	new target = UTIL_FindNearestOpponent(id,600+player_intelligence[id]*20)
	if (target == -1) return PLUGIN_HANDLED
	
	new DagonDamage = 0
	new Red = 0
	
	if (player_b_dagon[id] == 1)
	{
		DagonDamage = 30
		Red = 175
	}
	else if (player_b_dagon[id] == 2)
	{
		DagonDamage = 60
		Red = 225
	}
	else if (player_b_dagon[id] == 3)
	{
		DagonDamage = 90
		Red = 255
	}
	
	
	new Hit[3]
	get_user_origin(target,Hit)
	
	//Create Lightning
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(1) // TE_BEAMENTPOINT
	write_short(id)
	write_coord(Hit[0])
	write_coord(Hit[1])
	write_coord(Hit[2])
	write_short(lgt)
	write_byte(0)
	write_byte(1)
	write_byte(3)
	write_byte(10)	//WITD
	write_byte(60)
	write_byte(Red)
	write_byte(0)
	write_byte(0)
	write_byte(100)	//BRIGT
	write_byte(0)
	message_end()
	
	player_b_dagfired[id] = true
	
	//Apply damage
	if (get_user_health(target) - DagonDamage <= 0)
	{
		set_user_frags(id,get_user_frags(id)+1)
		award_xp(id,target)
		user_kill(target,1) 
		message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
		write_byte(id) 
		write_byte(target) 
		write_byte(0) 
		write_string("world") 
		message_end() 
	}
	else
	{
		set_user_health(target,get_user_health(target)-DagonDamage)
	}
		

	
	return PLUGIN_HANDLED
	
	
}

/* ==================================================================================================== */

public UTIL_Kill(attacker,id,weapon[])
{
	set_user_frags(attacker,get_user_frags(attacker)+1)
	award_xp(attacker,id)
	user_kill(id,1) 
	message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
	write_byte(attacker) 
	write_byte(id) 
	write_byte(0) 
	write_string(weapon) 
	message_end() 
	
        message_begin(MSG_ALL,gmsgScoreInfo) 
        write_byte(attacker) 
        write_short(get_user_frags(attacker)) 
        write_short(get_user_deaths(attacker)) 
        write_short(0) 
        write_short(get_user_team(attacker)) 
        message_end() 
         
        message_begin(MSG_ALL,gmsgScoreInfo) 
        write_byte(id) 
        write_short(get_user_frags(id)) 
        write_short(get_user_deaths(id)) 
        write_short(0) 
        write_short(get_user_team(id)) 
        message_end() 

}

/* ==================================================================================================== */

//Will return 1 if user has amount of money and then substract
public bool:UTIL_Buyformoney(id,amount)
{
	if (cs_get_user_money(id) >= amount)
	{
		cs_set_user_money(id,cs_get_user_money(id)-7000)
		return true
	}
	else
	{
		set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "Not enough money") 
		return false
	}
	
	return false
}
public buyrune(id)
{
	new text[513] 

	format(text, 512, "\ySelect Rune - ^n\w1. Tir [Can boost Dagon to Level III] - \r$7000^n\w2. Vex [Can boost Point Booster] - \r$5000^n\w3. Eth [Can Upgrade Air Booster] \r$6500^n\w4. Ral [Can Upgrade Gold Amplifier] \r$7000^n\w5. Sol [You get an item] \r$5000^n\w6. Exit") 

	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)
	show_menu(id, keys, text) 
	return PLUGIN_HANDLED  
} 


public select_rune_menu(id, key) 
{ 
	switch(key) 
	{ 
		case 0: 
		{	
			if (!UTIL_Buyformoney(id,7000))
				return PLUGIN_HANDLED
				
			//Tir rune
			if (player_b_dagon[id] > 0 && player_b_dagon[id] < 3)
			{
				player_b_dagon[id]++
				if (player_b_dagon[id] == 2) player_item_name[id] = "Dagon II"
				else if (player_b_dagon[id] == 3) player_item_name[id] = "Dagon III"	
				
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Dagon Upgraded")
			}
			
		}
		case 1:
		{
			if (!UTIL_Buyformoney(id,5000))
				return PLUGIN_HANDLED
				
			//Vex - Point BOoster
			if (item_boosted[id] == 0 && player_item_id[id] == 51)
			{
				item_boosted[id]++
				player_item_name[id] = "Vitality Booster"
				
				//Reset stas
				SubtractStats(id,player_b_extrastats[id])
				player_b_extrastats[id]+=2
				BoostStats(id,player_b_extrastats[id])
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Point Booster Upgraded")
			}
		}
		case 2:
		{
			if (!UTIL_Buyformoney(id,6500))
				return PLUGIN_HANDLED
				
			if (item_boosted[id] == 0 && player_item_id[id] == 49)
			{
				item_boosted[id]++
				player_item_name[id] = "Elemental Booster"
				player_b_jumpx[id]++
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Air Booster Upgraded")
			}
			
			
		}
		case 3:
		{
			if (!UTIL_Buyformoney(id,7000))
				return PLUGIN_HANDLED
				
			if (item_boosted[id] == 0 && player_item_id[id] == 3)
			{
				item_boosted[id]++
				player_item_name[id] = "Diamond Amplifier"
				player_b_damage[id]+=random_num(5,8)
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Gold Amplifier Upgraded")
			}
		}
	
		case 4: 
		{	
			if (!UTIL_Buyformoney(id,5000))
				return PLUGIN_HANDLED
			award_item(id,0)
			return PLUGIN_HANDLED
		}
		
		case 5: 
		{	
			return PLUGIN_HANDLED
		}
	}

	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

//Blocks fullupdate (can reset hud)
public fullupdate(id) 
{
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_scoutdamage(attacker_id,id,weapon)
{
	if (player_b_sniper[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_SCOUT)
	{

		if (!is_user_alive(id))
			return PLUGIN_HANDLED
			
		new kill = random_num(1,player_b_sniper[attacker_id])
		
		if (kill == 1)
		{
			UTIL_Kill(attacker_id,id,"scout")
		}
				
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public item_take_damage(id,damage)
{
	new itemdamage = get_cvar_num("diablo_durability")
	
	if (player_item_id[id] > 0 && item_durability[id] > 0 && itemdamage> 0 && damage > 5)
	{
		//Make item take damage
		if (item_durability[id] - itemdamage <= 0)
		{
			item_durability[id]-=itemdamage
			dropitem(id)
		}
		else
		{
			item_durability[id]-=itemdamage
		}
		
	}
}

/* ==================================================================================================== */

//From twistedeuphoria plugin
public Prethink_Doublejump(id)
{
	if(!is_user_alive(id)) 
		return PLUGIN_HANDLED

	if((get_user_button(id) & IN_JUMP) && !(get_entity_flags(id) & FL_ONGROUND) && !(get_user_oldbutton(id) & IN_JUMP))
	{
		if(jumps[id] < player_b_jumpx[id])
		{
			dojump[id] = true
			jumps[id]++
			return PLUGIN_HANDLED
		}
	}
	if((get_user_button(id) & IN_JUMP) && (get_entity_flags(id) & FL_ONGROUND))
	{
		jumps[id] = 0
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_HANDLED
}

public Postthink_Doubeljump(id)
{
	if(!is_user_alive(id)) 
		return PLUGIN_HANDLED
		
	if(dojump[id] == true)
	{
		new Float:velocity[3]	
		entity_get_vector(id,EV_VEC_velocity,velocity)
		velocity[2] = random_float(265.0,285.0)
		entity_set_vector(id,EV_VEC_velocity,velocity)
		dojump[id] = false
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public spawn_powerup(Float:sOrigin[3])
{
	new ent = create_entity("info_target") 
	entity_set_string(ent, EV_SZ_classname, "PowerUp") 
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS) 
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX) 
	entity_set_model(ent, "models/bag.mdl")  			
	set_rendering(ent, kRenderFxGlowShell, 0,0,0, kRenderNormal, 255)
	entity_set_origin(ent,sOrigin)
	entity_set_int(ent,EV_INT_iuser1,0)	//Amount of color glow
	new Float:maxs[3] = {16.0,16.0,6.0} 
	new Float:mins[3] = {-16.0,-16.0,-6.0} 
	entity_set_size(ent,mins,maxs) 
	entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 

}

public award_powerup(id)
{
	if (is_user_connected(id) && is_user_alive(id))
	{
		if (cs_get_user_money(id) < 5000)
			cs_set_user_money(id,5000)
		else if (cs_get_user_money(id) < 10000)
			cs_set_user_money(id,10000)
		else if (cs_get_user_money(id) < 16000)
			cs_set_user_money(id,16000)
			
		set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "Powerup: Money Boost")
	}
}

public Think_PowerUp(ent)
{
	//If set to delete
	if (entity_get_int(ent,EV_INT_iuser2) == 1)
	{
		remove_entity(ent)
		return PLUGIN_HANDLED
	}
		
	new glow = entity_get_int(ent,EV_INT_iuser1)
	
	if (glow < 255)
	{
		glow++
		entity_set_int(ent,EV_INT_iuser1,glow)
	}
		
	set_rendering(ent, kRenderFxGlowShell, 0,glow,0, kRenderNormal, 255)
	entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.5) 
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public register_place(kid)
{
	if (!spawnset)
		return PLUGIN_HANDLED
		
	new Place[3]
	get_user_origin(kid,Place,0)
	
	new distCTstart = get_distance(Place,CTstart) 
	new distTstart = get_distance(Place,Tstart)
	
	if (distCTstart > 300 && distTstart > 300 && abs(distCTstart - distTstart) < 150)
	{
		if (havespawn)
		{
			if (random_num(1,3) == 3)
				NextPowerup = Place
		}
		else
		{
			havespawn = true
			NextPowerup = Place
		}
		
	}
	
	return PLUGIN_CONTINUE
	
	
}

/* ==================================================================================================== */

public SpawnPowerup()
{
	if (!spawnset || !havespawn)
		return PLUGIN_HANDLED

	new chance = get_cvar_num("diablo_spawnchance")
	
	if (random_num(1,chance) == 1)
	{	
		
		//Dont spawn if one is already there
		if (find_ent_by_class(-1,"PowerUp") > 0)
			return PLUGIN_HANDLED
		
		//Spawn powerup
		new Float:spawnplace[3]
		IVecFVec(NextPowerup,spawnplace)
		spawn_powerup(spawnplace)
	}
	
	return PLUGIN_CONTINUE
		
	
}

/* ==================================================================================================== */

public eventGrenade(id) 
{
	new id = read_data(1)
	if (player_b_grenade[id] > 0 || player_b_smokehit[id] > 0)
	{
		set_task(0.1, "makeGlow", id)
	}
}

public makeGlow(id) 
{
	new grenade
	new greModel[100]
	grenade = get_grenade(id) 
	
	if( grenade ) 
	{	
		entity_get_string(grenade, EV_SZ_model, greModel, 99)
		
		if(equali(greModel, "models/w_hegrenade.mdl" ) && player_b_grenade[id] > 0 )	
			set_rendering(grenade, kRenderFxGlowShell, 255,0,0, kRenderNormal, 255)
				
		if(equali(greModel, "models/w_smokegrenade.mdl" ) && player_b_smokehit[id] > 0 )	
		{
			set_rendering(grenade, kRenderFxGlowShell, 0,255,255, kRenderNormal, 255)
		}
	}
}

/* ==================================================================================================== */

public BoostStats(id,amount)
{
	player_strength[id]+=amount
	player_dextery[id]+=amount
	player_agility[id]+=amount
	player_intelligence[id]+=amount
}

public SubtractStats(id,amount)
{
	player_strength[id]-=amount
	player_dextery[id]-=amount
	player_agility[id]-=amount
	player_intelligence[id]-=amount
}

/* ==================================================================================================== */

public SelectBotRace(id)
{
	if (!is_user_bot(id))
		return PLUGIN_HANDLED
	
	if (player_class[id] == 0)
		player_class[id] = random_num(1,5)
		
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public showskills(id)
{
	new Skillsinfo[512]
	format(Skillsinfo,511,"You have %i strength - this give you %i extra hitpoints<br><br>You have %i Dextery - this give a speed boost of %i%<br><br>You have %i Agility - This makes your chances to find unique items larger<br><br>You have %i intelligence - this will boost most USEMAGIC items damage<br>",player_strength[id],player_strength[id]*2,player_dextery[id],player_dextery[id]*2,player_agility[id],player_intelligence[id])
	showitem(id,"Skills","None","None", Skillsinfo)
}

